/**
*  Title:           GulchApp for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     hybrid applet / application interface for Gulch
*/

package gulch2000;

import java.awt.*;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JApplet;
import javax.swing.JFrame;
import pow2000.InterfaceMessageDef;

public class GulchApp extends JApplet {
    static boolean isStandalone = false;
    static JFrame frame = new JFrame();
    String server;
    int port;
    String db;

    /**
    Construct the application
    */
    public GulchApp() {
   }

    /**
    Main Application method
    */
    public static void main(String[] args) {
        GulchApp applet = new GulchApp();         //simulate a GulchApp applet
        applet.isStandalone = true;
        int loginNid = 0;                         //force user login processing
        frame.getContentPane().add(new GulchTabbedPane(frame, loginNid, InterfaceMessageDef.computerServer, InterfaceMessageDef.DBportValue, InterfaceMessageDef.DBdefaultSpace));
        frame.setTitle("WebGuide");

        applet.setStub(new GulchStandaloneStub(applet));

        applet.init();                          //call jbinit()
        applet.start();
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        frame.setSize(d.width - 100, d.height - 100);
        frame.setLocation((d.width - frame.getSize().width),
                          (d.height - frame.getSize().height));
        //frame.setSize(950,420);                 //initial size, centered in screen
        //frame.setLocation((d.width - frame.getSize().width) / 2,
        //                  (d.height - frame.getSize().height) / 2);
        frame.setVisible(true);
        WindowListener l = new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
        };
        frame.addWindowListener(l);
    }

    /**
    Initialize the applet
    */
    public void init() {
        jbInit();
    }

    /**
    Applet initialization.
    */
    private void jbInit() {
        this.getContentPane().setBackground(Color.magenta);
        this.setSize(1900,770);
        //this.setSize(950,410);
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        frame.setSize(d.width - 100, d.height - 100);                 //initial size, centered in screen
        frame.setLocation(0, 0);
        //get user's nid or force login procedure
        Integer theInteger = new Integer(getParameter("nid", "0"));
        int loginNid = theInteger.intValue();
        server = new String(getParameter("Server", InterfaceMessageDef.computerServer));
        theInteger = new Integer(getParameter("port", InterfaceMessageDef.DBport));
        port = theInteger.intValue();
        db = new String(getParameter("Database", InterfaceMessageDef.DBcentralSpace));
        if (! isStandalone) {
            frame.getContentPane().add(new GulchTabbedPane(this, loginNid, server, port, db));
            frame.setTitle("WebGuide");
            frame.setVisible(true);
            WindowListener l = new WindowAdapter() {
                public void windowClosing(WindowEvent e) {System.exit(0);}
            };
            frame.addWindowListener(l);
        }
    }

    /**
    Get Applet information
    */
    public String getAppletInfo() {
        return "GulchApp";
    }

    /**
    Get parameter info
    */
    public String[][] getParameterInfo() {
        return null;
    }

    /**
    get a parameter value
    */
    public String getParameter(String key, String def) {
        return isStandalone ? System.getProperty(key, def) :
            (getParameter(key) != null ? getParameter(key) : def);
    }

}
