
//Title:        GulchContentPane.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Pane for GulchEditing

package gulch2000;

import javax.swing.*;
import javax.swing.tree.*;


import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.text.Keymap;
import com.borland.jbcl.layout.VerticalFlowLayout;
import pow2000.NodeDataRow;

public class GulchContentPane extends JPanel {
    public GulchEditing parentPanel = null;
    VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
    JLabel kindLabel = new JLabel();
    JComboBox kindComboBox = new JComboBox();
    JLabel titleLabel = new JLabel();
    JScrollPane titleScrollPane;
    javax.swing.JTextArea titleTextArea = new javax.swing.JTextArea();
    JLabel contentLabel = new JLabel();
    JScrollPane contentScrollPane;
    javax.swing.JTextArea contentTextArea = new javax.swing.JTextArea();

    /**
    Construct the component as a JavaBean
    */
    public GulchContentPane() {
        System.out.println("WARNING: component called without pointer to parent");
        jbInit();
    }

    /**
    Construct the component with a pointer to its parent
    */
    public GulchContentPane(GulchEditing pane) {
        parentPanel = pane;
        jbInit();
    }

    /**
    Initialize the JavaBean
    */
    void jbInit() {
        //this.setPreferredSize(new Dimension(575, 330));
        this.setLayout(verticalFlowLayout1);
        kindLabel.setText("kind of note:");
        kindLabel.setFont(new Font("Dialog", 1, 14));
        refreshKindComboBox();
        titleLabel.setText("title:");
        titleLabel.setFont(new Font("Dialog", 1, 14));
        titleScrollPane = new JScrollPane(titleTextArea);
        titleScrollPane.setPreferredSize(new Dimension(50, 70));
        titleTextArea.setLineWrap(true);
        titleTextArea.setRows(3);
        titleTextArea.setFont(new Font("TimesRoman", 0, 12));
        titleTextArea.setText("enter title of note here");
        contentLabel.setText("content:");
        contentLabel.setFont(new Font("Dialog", 1, 14));
        contentScrollPane = new JScrollPane(contentTextArea);
        contentScrollPane.setPreferredSize(new Dimension(50, 160));
        contentTextArea.setLineWrap(true);
        contentTextArea.setFont(new Font("TimesRoman", 0, 12));
        contentTextArea.setText("enter content of note here");
        this.setBackground(Color.pink);
        this.add(kindLabel, null);
        this.add(kindComboBox, null);
        this.add(titleLabel, null);
        this.add(titleScrollPane, null);
        this.add(contentLabel, null);
        this.add(contentScrollPane, null);

        //define an Action and bind it to Enter keystroke
        //Action resizeAction = new AbstractAction() {
        //    public void actionPerformed(ActionEvent e) {
        //        //contentScrollPane.invalidate();
        //        contentScrollPane.update(contentScrollPane.getGraphics());
        //        //System.out.println("resizeAction");
        //    }
        //};
        //Keymap theKeymap = contentTextArea.getKeymap();
        //theKeymap.addActionForKeyStroke(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0, true), resizeAction);
    }

    /**
    Fill kindComboBox with alpha list of categories
    */
    void refreshKindComboBox() {
        Vector items = parentPanel.parent.state1.getListOfKinds();
        if (kindComboBox.getItemCount()>0) {kindComboBox.removeAllItems();}
        for (int i = 0; i < items.size(); i++) {
            NodeDataRow row = (NodeDataRow) items.elementAt(i);
            kindComboBox.addItem(row);
            if (row.getName().equalsIgnoreCase("comment")) {
                kindComboBox.setSelectedItem(row);
            }
        }
    }

    /**
    Set kindComboBox with one String
    */
    void setKindComboBox(String set) {
        if (kindComboBox.getItemCount()>0) {kindComboBox.removeAllItems();}
        NodeDataRow row = new NodeDataRow();
        row.setName(set);
        kindComboBox.addItem(row);
        kindComboBox.setSelectedItem(row);
    }

    /**
    Return nid of selected kind
    */
    int getSelectedKind() {
        NodeDataRow row = (NodeDataRow) kindComboBox.getSelectedItem();
        return row.getNid();
    }

    /**
    Set selected kind in kindComboBox -- from String
    */
    void setSelectedKind(String newSelectedKind) {
        for (int i = 0; i < kindComboBox.getItemCount(); i++) {
            NodeDataRow row = (NodeDataRow) kindComboBox.getItemAt(i);
            if (row.getName().equalsIgnoreCase(newSelectedKind)) {
                kindComboBox.setSelectedItem(row);
                return;
            }
        }
    }

    /**
    Set selected kind in kindComboBox -- from int
    */
    void setSelectedKind(int newSelectedKind) {
        for (int i = 0; i < kindComboBox.getItemCount(); i++) {
            NodeDataRow row = (NodeDataRow) kindComboBox.getItemAt(i);
            if (row.getNid()== newSelectedKind) {
                kindComboBox.setSelectedItem(row);
                return;
            }
        }
    }

    /**
    Return title
    */
    String getTitle() {
        return titleTextArea.getText();
    }

    /**
    Return content
    */
    String getContent() {
        return contentTextArea.getText();
    }

}














































