
//Title:        GulchEditingPane.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Component for GulchEditing

package gulch2000;

import javax.swing.*;
import javax.swing.tree.*;

import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.borland.jbcl.layout.VerticalFlowLayout;
import pow2000.TreeDataRow;
import pow2000.InterfaceMessageDef;

public class GulchEditingPane extends JPanel {
    GulchEditing parentPanel = null;
    GulchContentPane contentPane;
    GulchTabbedPane tabbedPane;
    GulchTreePane treePane;
    DefaultMutableTreeNode parent;
    DefaultMutableTreeNode currentNode;
    VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
    JLabel firstPerspectiveLabel = new JLabel();
    JTextField firstPerspectiveTextField = new JTextField();
    JPanel jPanel1 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JRadioButton afterRadioButton = new JRadioButton();
    JRadioButton belowRadioButton = new JRadioButton();
    ButtonGroup group = new ButtonGroup();
    JLabel secondLabel = new JLabel();
    JTextField secondTextField = new JTextField();
    JPanel jPanel2 = new JPanel();
    JButton cancelButton = new JButton();
    JButton okButton = new JButton();
    JTextArea msgTextArea = new JTextArea();
    String blankLine = "                                                                  ";
    String blankMessage = blankLine + blankLine + blankLine + blankLine + blankLine + blankLine + blankLine;
    JLabel firstLabel = new JLabel();
    JTextField firstTextField = new JTextField();
    JTextField secondPerspectiveTextField = new JTextField();
    JLabel secondPerspectiveLabel = new JLabel();

    /**
    Construct the component as a JavaBean
    */
    public GulchEditingPane() {
        System.out.println("WARNING: component called without pointer to parent");
        jbInit();
    }

    /**
    Construct the component with a pointer to its parent
    */
    public GulchEditingPane(GulchEditing pane) {
        parentPanel = pane;
        contentPane = (GulchContentPane) parentPanel.leftPane;
        tabbedPane = (GulchTabbedPane) parentPanel.parent;
        treePane = (GulchTreePane) tabbedPane.discuss1.leftPane;
        jbInit();
    }

    /**
    Initialize the JavaBean
    */
    void jbInit() {
        //this.setPreferredSize(new Dimension(300, 345));
        //this.setMinimumSize(new Dimension(250, 300));
        firstPerspectiveLabel.setText("in perspective:");
        firstPerspectiveLabel.setFont(new Font("Dialog", 1, 14));
        firstPerspectiveTextField.setText(" ");
        firstPerspectiveTextField.setEditable(false);
        jPanel1.setPreferredSize(new Dimension(341, 24));
        afterRadioButton.setText("after");
        afterRadioButton.setFont(new Font("Dialog", 1, 14));
        afterRadioButton.setSelected(true);
        belowRadioButton.setText("below");
        belowRadioButton.setFont(new Font("Dialog", 1, 14));
        secondLabel.setText("2nd selected item:");
        secondLabel.setFont(new Font("Dialog", 1, 14));
        secondTextField.setEditable(false);
        cancelButton.setText("Cancel");
        cancelButton.setFont(new Font("Dialog", 1, 12));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelButton_actionPerformed(e);
            }
        });
        okButton.setText("OK");
        okButton.setFont(new Font("Dialog", 1, 12));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                okButton_actionPerformed(e);
            }
        });
        msgTextArea.setLineWrap(true);
        msgTextArea.setMinimumSize(new Dimension(32, 15));
        msgTextArea.setText("messages:");
        msgTextArea.setForeground(new Color(0, 0, 147));
        firstLabel.setText("1st selected item:");
        firstLabel.setFont(new Font("Dialog", 1, 14));
        secondPerspectiveLabel.setText("in perspective:");
        secondPerspectiveLabel.setFont(new Font("Dialog", 1, 14));
        firstTextField.setEditable(false);
        secondPerspectiveTextField.setEditable(false);
        msgTextArea.setPreferredSize(new Dimension(341, 70));
        jPanel1.setLayout(flowLayout1);
        this.setLayout(verticalFlowLayout1);
        this.add(firstLabel, null);
        this.add(firstTextField, null);
        this.add(firstPerspectiveLabel, null);
        this.add(firstPerspectiveTextField, null);
        group.add(afterRadioButton);
        group.add(belowRadioButton);
        jPanel1.add(afterRadioButton, null);
        jPanel1.add(belowRadioButton, null);
        this.add(jPanel1, null);
        this.add(secondLabel, null);
        this.add(secondTextField, null);
        this.add(secondPerspectiveLabel, null);
        this.add(secondPerspectiveTextField, null);
        this.add(jPanel2, null);
        jPanel2.add(okButton, null);
        jPanel2.add(cancelButton, null);
        this.add(msgTextArea, null);
    }

    /**
    process different kinds of Statements
    */
    boolean processStatement(int kind) {
        boolean returnNow = false;
        String title = cleanString(contentPane.getTitle());
        String content = cleanString(contentPane.getContent());
        if (title.length() < 1) {
            msgTextArea.setText(blankMessage);
            msgTextArea.setText("You must first enter a title for your note.");
        }
        else {
            if (content.length() < 1) {
                msgTextArea.setText(blankMessage);
                msgTextArea.setText("You must first enter some content for your note.");
            }
            else {
                boolean after = afterRadioButton.isSelected();
                boolean atEnd = true;
                //save the new note to the database
                int newNid = tabbedPane.interfaceMgr1.addStatement(tabbedPane.getFirstPerspectiveNid(),
                                     kind, title, tabbedPane.getNid(), content, after);
                //force refresh of tree and scroll to edited note
                treePane.setDelayLastSelectedNid(newNid);
                tabbedPane.discuss1.refreshContent();
                returnNow = true;

 /**
                //save the new node to the tree
                //save the new node to the tree
                TreeDataRow row = new TreeDataRow();
                row.setDescription(title);
                row.setNid(newNid);
                parent = tabbedPane.getNode();
                if (after) {     //add after
                    currentNode = tabbedPane.getNode();
                    parent = (DefaultMutableTreeNode) currentNode.getParent();
                    atEnd = true;
                }
                else {           //add below
                    parent = tabbedPane.getNode();
                    atEnd = false;
                }
                treePane.addObject(parent, atEnd, row, true);
                treePane.setDelayLastSelectedNid(newNid);
                returnNow = true;
 */
            }
        }
        return returnNow;
    }

    /**
    process the OK button
    */
    void okButton_actionPerformed(ActionEvent e) {
        boolean returnNow = false;           //flag to not return from this pane
        tabbedPane.setHourglassCursor();     //signal user to wait during slow processing
        int kind = tabbedPane.state1.getSTATEMENT();

        //process addDiscussionButton
        if (tabbedPane.getButton().equals("addDiscussionButton")) {
            //if in author's perspective, just add normally with addDiscussion
            if ((tabbedPane.state1.getCurrentDisplayMode() == InterfaceMessageDef.GET_NODES_GROUP) ||
                 (tabbedPane.state1.getCurrentDisplayMode() == InterfaceMessageDef.GET_NODES_PERSONAL)) {
                      returnNow = processStatement(kind);   //normal processing in Personal mode
            }
            else {
                //if in Other's perspective, Discussion, Negotiation, Comparison, or Archive, then
                //add into group perspective, below closest ancestor that is in Group
                String title = cleanString(contentPane.getTitle());
                String content = cleanString(contentPane.getContent());
                if (title.length() < 1) {
                    msgTextArea.setText(blankMessage);
                    msgTextArea.setText("You must first enter a title for your note.");
                }
                else {
                    if (content.length() < 1) {
                        msgTextArea.setText(blankMessage);
                        msgTextArea.setText("You must first enter some content for your note.");
                    }
                    else {
                      boolean after = afterRadioButton.isSelected();
                      //find Nid of previous node
                      DefaultMutableTreeNode groupNode = tabbedPane.getNode();
                      TreeDataRow row = (TreeDataRow) groupNode.getUserObject();
                      int prevNid = row.getNid();
                      int p = tabbedPane.getFirstPerspectiveNid();
                      int groupP = tabbedPane.state1.getRootPerspectiveNid();
                      int groupNid = prevNid;
                      if (p == groupP) {
                        groupNid = prevNid;
                      }
                      else {     // add into Group
                        //find closest ancestor that is in Group perspective
                        groupNode = getGroupNode(tabbedPane.getNode());
                        if (groupNode == null) {
                            groupNid = 0;
                        }
                        else {
                            row = (TreeDataRow) groupNode.getUserObject();
                            groupNid = row.getNid();
                        }
                      }
                      //save the new note to the database -- using AddDiscussion
                      int newNid = tabbedPane.interfaceMgr1.addDiscussion(groupP, title, prevNid, groupNid, content, after);
                      if (newNid == 0) {
                          msgTextArea.setText(blankMessage);
                          msgTextArea.setText("WARNING: You cannot add discussion at this location.");
                      }
                      else {
                          //force refresh of tree in Group perspective and scroll to new note
                          tabbedPane.setCurrentPerspective(tabbedPane.state1.getRootPerspectiveNid());
                          treePane.setDelayLastSelectedNid(newNid);
                          tabbedPane.discuss1.refreshContent();
                          returnNow = true;
                      }
 /**                       //save the new node to the tree instead of refreshing
                        boolean atEnd = true;
                        TreeDataRow row = new TreeDataRow();
                        row.setDescription(title);
                        row.setNid(newNid);
                        parent = tabbedPane.getNode();
                        if (after) {     //add after
                            currentNode = tabbedPane.getNode();
                            parent = (DefaultMutableTreeNode) currentNode.getParent();
                            atEnd = true;
                        }
                        else {           //add below
                            parent = tabbedPane.getNode();
                            atEnd = false;
                        }
                        treePane.addObject(parent, atEnd, row, true);
                        treePane.setDelayLastSelectedNid(newNid);
                        returnNow = true;
*/
                    }
                }
            }
        }

        //process addProposalButton
        if (tabbedPane.getButton().equals("addProposalButton")) {
            returnNow = processStatement(tabbedPane.state1.getPROPOSAL());
        }

        //process addDecisionButton
        if (tabbedPane.getButton().equals("addDecisionButton")) {
            returnNow = processStatement(tabbedPane.state1.getDECISION());
        }

        //process addPrivateButton
        if (tabbedPane.getButton().equals("addPrivateButton")) {
            returnNow = processStatement(tabbedPane.state1.getPRIVATE());
        }

        //process addNewNoteButton
        if (tabbedPane.getButton().equals("addNewNoteButton")) {
            returnNow = processStatement(contentPane.getSelectedKind());
        }

        //process editNoteButton
        if (tabbedPane.getButton().equals("editNoteButton")) {
            String title = cleanString(contentPane.getTitle());
            String content = cleanString(contentPane.getContent());
            if (title.length() < 1) {
                msgTextArea.setText(blankMessage);
                msgTextArea.setText("You must first enter a title for your edited note.");
            }
            else {
                if (content.length() < 1) {
                    msgTextArea.setText(blankMessage);
                    msgTextArea.setText("You must first enter some content for your edited note.");
                }
                else {
                    //save the edited note to the database
                    int newNid = tabbedPane.interfaceMgr1.editStatement(contentPane.getSelectedKind(),
                                    tabbedPane.getFirstPerspectiveNid(), title, content, tabbedPane.getNid());
                    //force refresh of tree and scroll to edited note
                    treePane.setDelayLastSelectedNid(newNid);
                    tabbedPane.discuss1.refreshContent();
                    returnNow = true;
                }
            }
        }

        //process deleteNoteButton
        if (tabbedPane.getButton().equals("deleteNoteButton")) {
            //save the deletion of the note to the database
            tabbedPane.interfaceMgr1.deleteStatement(tabbedPane.getNid(), tabbedPane.getFirstPerspectiveNid());
            //delete the  node from the tree
            currentNode = tabbedPane.getNode();
            treePane.removeNode(currentNode);
            returnNow = true;
        }

        //process moveNoteButton (coming from selectSecondButton)
        //delete nid1 in p1; add nid1 after nid2 in p2
        //force refresh in p2
        if (tabbedPane.getButton().equals("moveNoteButton")) {
            //move nid1 in the database -- secondNode is parent of nid
            boolean after = afterRadioButton.isSelected();
            int newNid = tabbedPane.interfaceMgr1.moveItem(tabbedPane.getNid(), tabbedPane.getParentNid(),tabbedPane.getSecondNid(),
                                tabbedPane.getSecondParentNid(), tabbedPane.getFirstPerspectiveNid(), tabbedPane.getSecondPerspectiveNid(), after);
            //force refresh of tree in p2
            tabbedPane.setCurrentPerspective(tabbedPane.getSecondPerspectiveNid());
            treePane.setDelayLastSelectedNid(newNid);
            tabbedPane.discuss1.refreshContent();
            returnNow = true;
        }

        //process copyNoteButton
        //add nid1 after nid2 in p2
        //force refresh in p2
        if (tabbedPane.getButton().equals("copyNoteButton") | tabbedPane.getButton().equals("copyToHomeButton")) {
            //save the addition of nid1 after/below nid2 in p2 to the database
            boolean after = afterRadioButton.isSelected();
            int newNid = tabbedPane.interfaceMgr1.copyStatement(tabbedPane.getNid(), tabbedPane.getSecondNid(),
                                tabbedPane.getFirstPerspectiveNid(), tabbedPane.getSecondPerspectiveNid(), after);
            //force refresh of tree in p2
            treePane.setLastSelectedNid(newNid);
            tabbedPane.setCurrentPerspective(tabbedPane.getSecondPerspectiveNid());
            tabbedPane.discuss1.refreshContent();
            returnNow = true;
        }

        //process linkNoteButton
        //link nid1 to nid2 in p2
        //force refresh in p2
        if (tabbedPane.getButton().equals("linkNoteButton") | tabbedPane.getButton().equals("linkToHomeButton")) {
            //save the link of nid1 to nid2 in p3 to the database
            boolean after = afterRadioButton.isSelected();
            int newNid = tabbedPane.interfaceMgr1.linkItem(tabbedPane.getNid(), tabbedPane.getSecondNid(),
                                    tabbedPane.getFirstPerspectiveNid(), tabbedPane.getSecondPerspectiveNid(), after);
            //force refresh of tree in p2
            tabbedPane.setCurrentPerspective(tabbedPane.getSecondPerspectiveNid());
            treePane.setDelayLastSelectedNid(newNid);
            tabbedPane.discuss1.refreshContent();
            returnNow = true;
        }

        //clean up and go back home
        tabbedPane.setDefaultCursor();     //turn off wait cursor
        if (returnNow) {cleanUp(); }
    }

    /**
    getGroupNid()
    */
    private DefaultMutableTreeNode getGroupNode (DefaultMutableTreeNode theNode) {
        TreeDataRow row = (TreeDataRow) theNode.getUserObject();
        int p = row.getPerspective();
        if (p == tabbedPane.state1.getCOLAB_ROOT_PERSPECTIVE() || p == tabbedPane.state1.getRootPerspectiveNid() || p == 0) {
            return theNode;                  // if this Nid is in Group perspective
        }
        else {        // else try its ancestors
            parent = (DefaultMutableTreeNode) theNode.getParent();
            row = (TreeDataRow) parent.getUserObject();
            p = row.getPerspective();
            return getGroupNode(parent);
        }
    }

    /**
    process the cancel button
    */
    private void cancelButton_actionPerformed(ActionEvent e) {
        cleanUp();
    }

    /**
    remove the Editing tab and return tothe previous tab
    */
    private void cleanUp() {
        tabbedPane.removeEdit();
        tabbedPane.tabbedPane.setSelectedComponent(tabbedPane.getComponent());
    }

    /**
    replace bad characters
    */
    private String cleanString(String s) {
        s = s.replace('\u201C', '"');       //reverse double curly quote
        s = s.replace('\u201D', '"');       //forward double curly quote
        s = s.replace('\u2018', '\'');      //reverse single curly quote
        s = s.replace('\u2019', '\'');      //forward single curly quote
        return s;
    }

}

























