//Title:        GulchMapPane.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Component for GulchDiscuss

package gulch2000;

import javax.swing.*;
import javax.swing.tree.*;



import java.io.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.borland.jbcl.layout.*;
import pow2000.TreeDataRow;
//import XMLConvert.dataset;
//import XMLConvert.note;
//import XMLConvert.link;

public class GulchMapPane extends JPanel {
    public GulchMap parentPanel = null;
    GulchTreePane treePane;
    GulchTabbedPane tabbedPane;
    DefaultMutableTreeNode node;
    DefaultMutableTreeNode secondNode;
    private String perspectiveName = "";
    private int maxDepth = 0;
    private int currentDepth = 0;
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JTextArea messageTextArea = new JTextArea();
    JRadioButton titleRadioButton = new JRadioButton();
    JRadioButton contentRadioButton = new JRadioButton();
    JRadioButton graphicRadioButton = new JRadioButton();
    ButtonGroup group = new ButtonGroup();
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    JButton jButton3 = new JButton();
    JButton jButton4 = new JButton();
    JButton selectedButton = new JButton();
    JButton day14Button = new JButton();
    BorderLayout borderLayout1 = new BorderLayout();
    XYLayout xYLayout1 = new XYLayout();
    JTextField authorTextField = new JTextField();
    JLabel jLabel1 = new JLabel();
    String blankLine = "                                                                  ";
    String blankMessage = blankLine + blankLine + blankLine + blankLine + blankLine + blankLine + blankLine;
    GridLayout gridLayout1 = new GridLayout();
    JButton day7Button = new JButton();
    JButton day2Button = new JButton();
    JButton displayedButton = new JButton();
    JPanel jPanel3 = new JPanel();
    JPanel jPanel4 = new JPanel();

    /**
    Construct the component as a JavaBean
    */
    public GulchMapPane() {
        System.out.println("WARNING: component called without pointer to parent");
        jbInit();
    }

    /**
    Construct the component with a pointer to its parent
    */
    public GulchMapPane(GulchMap pane) {
        parentPanel = pane;
        treePane = (GulchTreePane) parentPanel.leftPane;
        tabbedPane = (GulchTabbedPane) parentPanel.parent;
        jbInit();
    }

    /**
    Initialize the JavaBean
    */
    void jbInit() {
        //this.setPreferredSize(new Dimension(300, 345));
        this.setLayout(borderLayout1);
        this.setBackground(SystemColor.controlShadow);
        this.setMinimumSize(new Dimension(250, 300));
        jPanel1.setBackground(SystemColor.control);
        jPanel1.setLayout(gridLayout1);
        jPanel2.setBackground(SystemColor.control);
        jPanel2.setLayout(xYLayout1);
        titleRadioButton.setText("show title");
        titleRadioButton.setSelected(true);
        contentRadioButton.setText("show content");
        messageTextArea.setLineWrap(true);
        messageTextArea.setRows(4);
        messageTextArea.setText("messages:");
        messageTextArea.setForeground(new Color(0, 0, 170));
        messageTextArea.setPreferredSize(new Dimension(205, 75));
        messageTextArea.setFont(new Font("Dialog", 1, 12));
        messageTextArea.setEditable(false);
        jButton1.setMaximumSize(new Dimension(120, 27));
        jButton1.setMinimumSize(new Dimension(100, 27));
        jButton1.setPreferredSize(new Dimension(100, 27));
        jButton1.setText("add discussion of note");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton1_actionPerformed(e);
            }
        });
        jButton2.setMaximumSize(new Dimension(120, 27));
        jButton2.setMinimumSize(new Dimension(100, 27));
        jButton2.setPreferredSize(new Dimension(100, 27));
        jButton2.setText("add new note to selected note");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton2_actionPerformed(e);
            }
        });
        jButton3.setMaximumSize(new Dimension(120, 27));
        jButton3.setMinimumSize(new Dimension(100, 27));
        jButton3.setPreferredSize(new Dimension(100, 27));
        jButton3.setText("edit selected note");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton3_actionPerformed(e);
            }
        });
        jButton4.setMaximumSize(new Dimension(120, 27));
        jButton4.setMinimumSize(new Dimension(100, 27));
        jButton4.setPreferredSize(new Dimension(100, 27));
        jButton4.setText("delete selected note");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButton4_actionPerformed(e);
            }
        });
        selectedButton.setText("print selected notes");
        selectedButton.setMaximumSize(new Dimension(120, 27));
        selectedButton.setMinimumSize(new Dimension(100, 27));
        selectedButton.setPreferredSize(new Dimension(100, 27));
        selectedButton.setMargin(new Insets(2, 2, 2, 2));
        selectedButton.setRolloverEnabled(true);
        selectedButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                selectedButton_actionPerformed(e);
            }
        });
        day14Button.setMaximumSize(new Dimension(120, 27));
        day14Button.setMinimumSize(new Dimension(100, 27));
        day14Button.setPreferredSize(new Dimension(100, 27));
        day14Button.setText("print notes from last 2 weeks");
        day14Button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                day14Button_actionPerformed(e);
            }
        });
        authorTextField.setText("current author");
        authorTextField.setForeground(new Color(0, 0, 162));
        authorTextField.setFont(new Font("SansSerif", 1, 12));
        authorTextField.setEditable(false);
        jLabel1.setText("author:");
        gridLayout1.setHgap(1);
        gridLayout1.setRows(11);
        gridLayout1.setColumns(1);
        gridLayout1.setVgap(1);
        day7Button.setText("print notes from last 7 days");
        day7Button.setMaximumSize(new Dimension(120, 27));
        day7Button.setMinimumSize(new Dimension(100, 27));
        day7Button.setPreferredSize(new Dimension(100, 27));
        day7Button.setMargin(new Insets(2, 2, 2, 2));
        day7Button.setRolloverEnabled(true);
        day2Button.setText("print notes in last 2 days");
        day2Button.setMaximumSize(new Dimension(120, 27));
        day2Button.setMinimumSize(new Dimension(100, 27));
        day2Button.setPreferredSize(new Dimension(100, 27));
        day2Button.setMargin(new Insets(2, 2, 2, 2));
        day2Button.setRolloverEnabled(true);
        //jButton10.setText("email from selected note");
        displayedButton.setText("print displayed notes");
        displayedButton.setMaximumSize(new Dimension(120, 27));
        displayedButton.setMinimumSize(new Dimension(100, 27));
        displayedButton.setPreferredSize(new Dimension(100, 27));
        displayedButton.setMargin(new Insets(2, 2, 2, 2));
        displayedButton.setRolloverEnabled(true);
        jPanel3.setMinimumSize(new Dimension(33, 33));
        jPanel3.setPreferredSize(new Dimension(80, 80));
        jPanel4.setMinimumSize(new Dimension(30, 30));
        jPanel4.setPreferredSize(new Dimension(80, 80));
        displayedButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                displayedButton_actionPerformed(e);
            }
        });
        day2Button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                day2Button_actionPerformed(e);
            }
        });
        day7Button.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                day7Button_actionPerformed(e);
            }
        });
        graphicRadioButton.setText("graphic display");
        this.add(jPanel2, BorderLayout.NORTH);
        group.add(titleRadioButton);
        group.add(contentRadioButton);
        group.add(graphicRadioButton);
        jPanel2.add(titleRadioButton, new XYConstraints(10, 27, 78, -1));
        jPanel2.add(contentRadioButton, new XYConstraints(114, 26, 102, -1));
        jPanel2.add(graphicRadioButton, new XYConstraints(235, 25, 102, -1));
        jPanel2.add(authorTextField, new XYConstraints(50, 5, 241, 18));
        jPanel2.add(jLabel1, new XYConstraints(7, 5, 57, 18));
        this.add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(jButton1, null);
        jPanel1.add(jButton2, null);
        jPanel1.add(jButton3, null);
        jPanel1.add(jButton4, null);
        jPanel1.add(displayedButton, null);
        jPanel1.add(selectedButton, null);
        jPanel1.add(day2Button, null);
        jPanel1.add(day7Button, null);
        jPanel1.add(day14Button, null);
        this.add(jPanel4, BorderLayout.EAST);
        this.add(messageTextArea, BorderLayout.SOUTH);
        this.add(jPanel3, BorderLayout.WEST);
    }

    /**
    Check permissions to use buttons.
    If in author's home perspective, enable everything except link-to-home and copy-to-home.
    Except if author is guest, then also disable edit and delete.
    If not in author's home only enable copy-to-home and link-to-home.
    Option to select second note must be enabled when needed
    */
    void checkPermissions() {
        if (tabbedPane.getAuthorName().equalsIgnoreCase("Admin") ) {
            //Admin has permission to do everything everywhere anytime
            jButton1.setEnabled(true);
            jButton2.setEnabled(true);
            jButton3.setEnabled(true);
            jButton4.setEnabled(true);
            selectedButton.setEnabled(true);
            day2Button.setEnabled(true);
            day7Button.setEnabled(true);
            displayedButton.setEnabled(true);
            day14Button.setEnabled(true);
        }
        else {
            if (tabbedPane.getCurrentPerspective() == tabbedPane.getHomePerspective()) {
                //in author's home perspective
                jButton1.setEnabled(true);
                jButton2.setEnabled(true);
                if (tabbedPane.getAuthorName().equalsIgnoreCase("guest") ) {
                    jButton3.setEnabled(false);
                    jButton4.setEnabled(false);
                }
                else {
                    jButton3.setEnabled(true);
                    jButton4.setEnabled(true);
                }
                selectedButton.setEnabled(true);
                day2Button.setEnabled(false);
                day7Button.setEnabled(false);
                displayedButton.setEnabled(true);
                day14Button.setEnabled(false);
            }
            else {
                //browsing in other perspectives
                jButton1.setEnabled(false);
                jButton2.setEnabled(false);
                jButton3.setEnabled(false);
                jButton4.setEnabled(false);
                selectedButton.setEnabled(false);
                day2Button.setEnabled(true);
                day7Button.setEnabled(true);
                displayedButton.setEnabled(true);
                day14Button.setEnabled(false);
            }
        }
        //allow discussion in "comparison" perspectives
        if (tabbedPane.getCurrentPerspectiveName().toLowerCase().indexOf("comparison") > 0) {
            jButton1.setEnabled(true);
        }
    }

    /**
    disable all buttons except SecondButton
    */
    void displaySecondButton() {
        jButton1.setEnabled(false);
        jButton2.setEnabled(false);
        jButton3.setEnabled(false);
        jButton4.setEnabled(false);
        selectedButton.setEnabled(false);
        day2Button.setEnabled(false);
        day7Button.setEnabled(false);
        displayedButton.setEnabled(false);
        day14Button.setEnabled(true);
    }

    /**
    addDiscussionButton. add discussion of selected note
    */
    void jButton1_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankLine);
                messageTextArea.setText("Message: You must select a note to discuss first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("addDiscussionButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                //switch to Editing component, which will return here
                tabbedPane.addEdit();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to discuss first.");
            return;
        }
    }

    /**
    addNewNoteButton. add new note to selected note
    */
    void jButton2_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to link to first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("addNewNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                //switch to Editing component, which will return here
                tabbedPane.addEdit();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to link to first.");
            return;
        }
    }

    /**
    editNoteButton. edit selected note
    */
    void jButton3_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to edit first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("editNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setKind(row.getKind());
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                //switch to Editing component, which will return here
                tabbedPane.addEdit();
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to edit first.");
            return;
        }
    }

    /**
    deleteNoteButton. delete selected note
    */
    void jButton4_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to delete first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("deleteNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                //switch to Editing component, which will return here
                tabbedPane.addEdit();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to delete first.");
            return;
        }
    }

    /**
    moveNoteButton. move selected note after/below second note within same perspective
    */
    void jButton5_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            DefaultMutableTreeNode parentNode = (DefaultMutableTreeNode) node.getParent();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to move first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                TreeDataRow parentRow = (TreeDataRow) parentNode.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("moveNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setParentNid(parentRow.getNid());    
                tabbedPane.setNid(row.getNid());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to move this one after or below.  " +
                                        "Then press the button to Select Note as Second Item.");
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to move first.");
            return;
        }
    }

    /**
    copyNoteButton. copy selected note after/below second note within same perspective
    */
    void jButton6_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to copy first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("copyNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to copy this one after or below.  " +
                                        "Then press the button to Select Note as Second Item.");
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to copy first.");
            return;
        }
    }

    /**
    linkNoteButton. link selected note to a new parent note within same perspective
    */
    void selectedButton_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to be linked first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("linkNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to link to as this one's parent.  " +
                                        "Then press the button to Select Note as Second Item.");
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to be linked first.");
            return;
        }
    }

    /**
    copyToHomeButton. copy selected note after/below second note in home perspective
    */
    void day2Button_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to copy first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("copyToHomeButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to copy this one after or below.  " +
                                        "The second note must be in your home personal perspective. " +
                                        "Then press the button to Select Note as Second Item.");
                //switch to home perspective in perspectiveComboBox and refresh tree
                tabbedPane.setCurrentPerspective(tabbedPane.getHomePerspective());
                treePane.refreshPerspectiveComboBox();
                treePane.refreshTree();
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to copy first.");
            return;
        }
    }

    /**
    linkToHomeButton. link selected note after/below second note in home perspective
    */
    void day7Button_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to be linked first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //save component, button, node and nid of selected note in parent variables
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("linkToHomeButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: Now you must select a SECOND note to link to as this one's parent.  " +
                                        "The second note must be in your home personal perspective. " +
                                        "Then press the button to Select Note as Second Item.");
                //switch to home perspective in perspectiveComboBox and refresh tree
                tabbedPane.setCurrentPerspective(tabbedPane.getHomePerspective());
                treePane.refreshPerspectiveComboBox();
                treePane.refreshTree();
                //now disable perspectives changer and wait for selectSecondButton to be pressed
                treePane.perspectiveComboBox.setEnabled(false);
                displaySecondButton();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to be linked first.");
            return;
        }
    }

    /**
    xmlButton. Create XML file
    void displayedButton_actionPerformed(ActionEvent e) {
        try {
            //get Vector of TreeDataRows
            //Vector v = tabbedPane.state1.getTreeOfNodes();
            //initialize Vector of TreeDataRows
            Vector v = new Vector();
            //step through JTree to find visible notes and add them to v
// here is where Witt and Rajesh put their code
            //write file of XML
            String s = translateXml(v);
            //send file s to server
            tabbedPane.interfaceMgr1.multiNodeDisplay(s);

            //store file on server
            String fileName = "webguide.xml";
            FileOutputStream fos = new FileOutputStream(fileName);
            PrintWriter pw = new PrintWriter(fos, true);
            pw.print(s);
            pw.close();
            fos.close();
            //call CGI script
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to email about first.");
            return;
        }
    }
    */

    /**
    xmlButton. Create XML file
    */
    void displayedButton_actionPerformed(ActionEvent e) {
        try {
            //get Vector of TreeDataRows which are currently open
            Vector v = treePane.getOpenRows();

            // Some test code to verify that getOpenRows worked
            for (int i = 0; i < v.size(); i++) {
              TreeDataRow node = (TreeDataRow)v.elementAt(i);
              System.out.println(node.asString());
            }

            //write file of XML
 //           String s = translateXml(v);
            //send file s to server
//            tabbedPane.interfaceMgr1.multiNodeDisplay(s);

/**
            //store file on server
            String fileName = "webguide.xml";
            FileOutputStream fos = new FileOutputStream(fileName);
            PrintWriter pw = new PrintWriter(fos, true);
            pw.print(s);
            pw.close();
            fos.close();
            //call CGI script
 */
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: Caught an exception while displaying rows..");
            return;
        }
    }

    /**
    emailButton. send email from selected note
    void jButton10_actionPerformed(ActionEvent e) {
        try {
            //get nid of selected node
            node = treePane.getSelectedNode();
            if (node == null) {
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: You must select a note to email about first.");
            }
            else {
                TreeDataRow row = (TreeDataRow) node.getUserObject();
                //call cgi script and pass it variables pointing to the selected note, perspectiveNid, author and database
                tabbedPane.setComponent(tabbedPane.discuss1);
                tabbedPane.setButton("emailNoteButton");
                tabbedPane.setNode(node);
                tabbedPane.setNid(row.getNid());
                tabbedPane.setFirstSelection(row.getDescription());
                tabbedPane.setSecondSelection("");
                tabbedPane.setFirstPerspectiveNid(treePane.getSelectedPerspectiveNid());
                tabbedPane.setFirstPerspectiveName(treePane.getSelectedPerspectiveName());
                messageTextArea.setText(blankMessage);
                messageTextArea.setText("Message: The email function is not yet operational." );
        //        messageTextArea.setText("Message: Fill out the email form below and send it.  " +
        //                                "Your message and any email responses to it will appear below the note you selected.");
                //done -- user can do something else
                checkPermissions();
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to email about first.");
            return;
        }
    }
    */

    /**
    selectSecondButton. select note as second item for editing
    */
    void day14Button_actionPerformed(ActionEvent e) {
        try {
            // process rest of move, copy, virtual copy or link
            if ((tabbedPane.getButton().equals("moveNoteButton")) |
                    (tabbedPane.getButton().equals("copyNoteButton")) |
                    (tabbedPane.getButton().equals("linkNoteButton")) |
                    (tabbedPane.getButton().equals("copyToHomeButton")) |
                    (tabbedPane.getButton().equals("linkToHomeButton"))  ) {
                //store second selected note and perspective
                secondNode = treePane.getSelectedNode();
                TreeDataRow secondRow = (TreeDataRow) secondNode.getUserObject();
                int firstNid = tabbedPane.getNid();
                //if (secondNode == null | firstNid == secondRow.getNid()) {     //would not allow copy under same note in dif p
                if (secondNode == null) {
                    messageTextArea.setText(blankMessage);
                    messageTextArea.setText("Message: You must select a note to serve as second item.");
                }
                else {
                    //save secondNode in parent variables
                    DefaultMutableTreeNode secondParentNode = (DefaultMutableTreeNode) secondNode.getParent();
                    TreeDataRow secondParentRow = (TreeDataRow) secondParentNode.getUserObject();
                    tabbedPane.setSecondParentNid(secondParentRow.getNid());
                    tabbedPane.setSecondNode(secondNode);
                    tabbedPane.setSecondNid(secondRow.getNid());
                    tabbedPane.setSecondSelection(secondRow.getDescription());
                    tabbedPane.setSecondPerspectiveNid(tabbedPane.getCurrentPerspective());
                    tabbedPane.setSecondPerspectiveName(tabbedPane.getCurrentPerspectiveName());
                    //switch to Editing component, which will return here
                    treePane.perspectiveComboBox.setEnabled(true);
                    checkPermissions();
                    tabbedPane.addEdit();
                }
            }
        }
        catch (Exception ex) {
            messageTextArea.setText(blankMessage);
            messageTextArea.setText("WARNING: You must select a note to serve as second item.");
            return;
        }
    }

    /**
    translateXml() translate a Vector of TreeDataRows into an XML String
    by Gerry --- stub only
    */
    public String translateXml(Vector v) {
        Date now = new Date();
        String returnString = "";
        StringBuffer s = new StringBuffer("<!-- XML generated by WebGuide -->");
        s.append("<DATASET SYSTEM=WebGuide_2000 DESCRIPTION=tree of data for a perspective " +
                "COMMENT=" + tabbedPane.state1.getCurrentPerspectiveName() + " AUTHOR=" + tabbedPane.state1.getCurrentAuthorName() + " " +
                "CREATED=" + now.toString().substring(0, 11) + " XML_VERSION=1.0   ");

        for (int i = 0; i < v.size(); i++) {
            TreeDataRow row = (TreeDataRow) v.elementAt(i);
            Integer nid = new Integer(row.getNid());
            String nidStr = nid.toString();
            s.append(" <NOTE NID=" + nidStr);
            s.append(" KIND=" + row.getKindName());
            s.append(" TITLE=" + row.getName());
        }
        returnString = s.toString();
        return returnString;
    }

    /**
    translateXml() translate a Vector of TreeDataRows into an XML String
    by Aaron Martin
    {
    public String translateXml(Vector v)
        Date now = new Date();
        Dataset master = new Dataset();
        master.addComment("automatically generated by WebGuide");
        master.addDescription("generated by webguide");
        master.setCreated(now.toGMTString());
        master.setCreator("trasnlateXML");
        String returnString = "";
       StringBuffer s = new StringBuffer("<!-- XML generated by WebGuide -->");

       for(int i=0; i<v.size(); i++) {
        TreeDataRow temp = (TreeDataRow) v.get(i);
        Note tempNote = new Note(temp.getNid());
        tempNote.setContent(temp.getDescription());
        tempNote.addAuthor(temp.getAuthorName());
        tempNote.setNote_kind(temp.getKindName());
        tempNote.addAdditional("perspective:" + temp.getPerspectiveName());
        tempNote.setTitle(temp.getName());
        tempNote.setCreated(temp.getCreated().toGMTString());
        tempNote.setSequence(temp.getSequence());
        master.addNote(tempNote);
        if(temp.getParent() != -1)  //I don't know the real value
          master.addLink(temp.getParent(), tempNote.getID());
       }

       master.generateNRXML(0, s);
        returnString = s.toString();
        return returnString;
    }
    */

    public void setAuthorTextField(String msg) {
        authorTextField.setText(msg);
    }

    public void setMessageTextArea(String msg) {
        messageTextArea.setText(msg);
    }

}










































