
//Title:        GulchPane.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  template for GulchTabbedPane components with splitPane

package gulch2000;

import java.awt.*;
import java.util.*;
import javax.swing.*;
import pow2000.TreeDataRow;
import pow2000.InterfaceState;

public class GulchPane extends JPanel {
    GulchTabbedPane parent = null;
    //InterfaceState state1 = null;
    JSplitPane splitPane;
    JScrollPane leftView;
    JScrollPane rightView;
    public JPanel leftPane;
    public JPanel rightPane;

    /**
    Construct the component as a JavaBean
    */
    public GulchPane() {
        System.out.println("WARNING: GulchPane component called without pointer to parent");
        jbInit();
    }

    /**
    Construct the component with a pointer to its parent, the GulchTabbedPane
    */
    public GulchPane(GulchTabbedPane pane) {
        parent = pane;
        //state1 = parent.state1;
        jbInit();
    }

    /**
    Initialize the JavaBean
    */
    void jbInit() {
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        //define leftpane and rightPane and initialize them in Panes that extend GulchPane
        splitPaneSetup();         //this is overridden in extension to GulchPane
        leftView = new JScrollPane(leftPane);
        rightView = new JScrollPane(rightPane);
        splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
        splitPane.setLeftComponent(leftView);
        splitPane.setRightComponent(rightView);
        Dimension leftPreferredSize = new Dimension(d.width - 440, d.height - 190);   // fills App (1900, 770)
        Dimension rightPreferredSize = new Dimension(310, 355);
        //Dimension leftPreferredSize = new Dimension(625, 355);   // fills App (950,410) for 1024x768 monitior
        //Dimension rightPreferredSize = new Dimension(310, 355);
        leftView.setPreferredSize(leftPreferredSize);
        rightView.setPreferredSize(rightPreferredSize);
        //splitPane.setDividerLocation(605);
        this.setBackground(Color.magenta);
        this.add(splitPane);
        refreshContent();
    }

    /**
    dummy splitPaneSetup()
    Set up leftPane and rightPane
    */
    void splitPaneSetup() {
        System.out.println("WARNING: dummy method executed; splitPaneSetup should be overridden.");
    }

    /**
    dummy processTreeSelection()
    */
    void processTreeSelection(TreeDataRow theRow) {
        System.out.println("WARNING: dummy method executed; processTreeSelection should be overridden.");
    }

    /**
    dummy refreshContent()
    */
    void refreshContent() {
         System.out.println("WARNING: dummy method executed; refreshContent should be overridden.");
   }

    /**
    dummy getRootName()
    */
    String getRootName() {
        System.out.println("WARNING: dummy method executed; getRootName should be overridden.");
        return "temp";
    }

    /**
    dummy getRootNid()
    */
    int getRootNid() {
        System.out.println("WARNING: dummy method executed; getRootNid should be overridden.");
        return 0;
    }

    /**
    dummy getList()
    */
    Vector getList() {
        System.out.println("WARNING: dummy method executed; getList should be overridden.");
        return new Vector();
    }

}

