
//Title:        GulchPerspectives.java
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Perspectives component for Gulch

package gulch2000;

import java.util.*;
import pow2000.TreeDataRow;

public class GulchPerspectives extends GulchPane {

    /**
    Construct the component as a JavaBean
    */
    public GulchPerspectives() {
        super();
        System.out.println("WARNING: component called without pointer to parent");
    }

    /**
    Construct the component with a pointer to its parent
    */
    public GulchPerspectives(GulchTabbedPane pane) {
        super(pane);
    }

    /**
    override dummy splitPaneSetup()
    Set up leftPane as GulchTreePane and rightPane as GulchPerspectivesPane
    */
    void splitPaneSetup() {
        leftPane = new GulchTreePane(this);
        rightPane = new GulchPerspectivesPane(this);
    }

    /**
    dummy processTreeSelection()
    */
    void processTreeSelection(TreeDataRow theRow) {
        System.out.println("WARNING: dummy method executed; processTreeSelection should be overridden.");
    }

    /**
    override dummy refreshContent()
    */
    void refreshContent() {
        //initialize GulchTreePane with discussion content in tree
        GulchTreePane treePane = (GulchTreePane) leftPane;
        treePane.refreshTree();
        //initialize GulchPerspectivesPane
        GulchPerspectivesPane perspPane = (GulchPerspectivesPane) rightPane;
        perspPane.newTextField.setText(" ");
        perspPane.firstTextField.setText(" ");
        perspPane.secondTextField.setText(" ");
        perspPane.msgTextArea.setText("messages: ");
   }

    /**
    getRootName()
    */
    String getRootName() {
        return "perspective hierarchy";                           //set name in root to "perspective hierarchy"
    }

    /**
    getRootNid()
    */
    int getRootNid() {
        return parent.state1.getCOLAB_ROOT_PERSPECTIVE();      //set nid in root to getCOLAB_ROOT_PERSPECTIVE
    }

    /**
    getList()
    */
    Vector getList() {
        return parent.state1.getTreeOfPerspectives();          //get the Tree of perspectives
    }

}

