/**
*  Title:           GulchStandaloneStub for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     Provides stubs for hybrid Applet / Application
*/

package gulch2000;

import java.applet.*;
import java.awt.Image;
import java.net.URL;
import java.util.Enumeration;

public class GulchStandaloneStub implements AppletStub, AppletContext, Enumeration, AudioClip {
    Applet applet;

    public GulchStandaloneStub(Applet applet) {
        this.applet = applet;
    }

    //AppletStub methods
    public void appletResize(int width, int height) {
        applet.setSize(width, height);
    }

    public URL getCodeBase() {
        try {
            return new URL("bogus://localhost/");
        }
        catch (java.net.MalformedURLException ex) {
            return null;
        }
    }

    public String getParameter(String name) {
        return System.getProperty(name, null);
    }

    public URL getDocumentBase() { return getCodeBase(); }

    public boolean isActive() { return true; }

    public AppletContext getAppletContext() { return this; }

    //AppletContext methods
    public Image getImage(URL url) {
        if (url.getProtocol().equals("bogus")) {
            url = applet.getClass().getResource(url.getFile());
        }
        if (url == null) return null;
        return applet.getToolkit().getImage(url);
    }

    public Applet getApplet(String name) { return null; }

    public Enumeration getApplets() { return this; }

    public AudioClip getAudioClip(URL url) { return this; }

    public void showDocument(URL url) { }

    public void showDocument(URL url, String target) { }

    public void showStatus(String status) { }

    //Enumeration methods
    public boolean hasMoreElements() { return false; }

    public Object nextElement() { return null; }

    //AudioClip methods
    public void play() { }

    public void loop() { }

    public void stop() { }

}

