//Title:        GulchTreePane.java
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Gerry Stahl
//Company:      L3D
//Description:  Pane with tree and buttons

package gulch2000;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.tree.*;



import javax.swing.event.*;
import pow2000.TreeDataRow;
import pow2000.NodeDataRow;
import pow2000.InterfaceMessageDef;

public class GulchTreePane extends JPanel {
    private GulchPane parent;
    private GulchTabbedPane tabbedPane;
    protected TreeDataRow rootRow;
    protected DefaultMutableTreeNode rootNode;    //root of the tree
    protected TreePath rootPath;
    private Vector theList = new Vector();  //Vector of TreeDataRows for contents of tree
    protected DefaultTreeModel treeModel;
    protected JTree tree;
    private Toolkit toolkit = Toolkit.getDefaultToolkit();
    private JButton refreshButton = new JButton();
    private JLabel inLabel = new JLabel();
    private JButton collapseButton = new JButton();
    private JButton colOneButton = new JButton();
    private JButton expOneButton = new JButton();
    private JButton expandButton = new JButton();
    private JButton explodeButton = new JButton();
    private String perspectiveName = "perspectiveName";
    private int lastSelectedNid = 0;
    private boolean delayLastSelectedNid = false;
    private int maxDepth = 0;
    private int currentDepth = 0;
    JPanel jPanel1 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JPanel jPanel2 = new JPanel();
    FlowLayout flowLayout2 = new FlowLayout();
    BorderLayout borderLayout1 = new BorderLayout();
    JComboBox perspectiveComboBox = new JComboBox();
    JScrollPane treeScrollPane;
    private JButton discussionButton = new JButton();
    private JButton groupButton = new JButton();
    private JButton negotiationButton = new JButton();
    private JButton personalButton = new JButton();
    private JButton comparisonButton = new JButton();
    private int currentP = 0;
    private boolean start = false;

    /**
    Construct the component as a JavaBean
    */
    public GulchTreePane() {
        System.out.println("WARNING: component called without pointer to parent");
    }

    public GulchTreePane(GulchPane theParent) {
        parent = theParent;
        tabbedPane = (GulchTabbedPane) parent.parent;
        jbInit();
    }

    private void jbInit() {
        //this.setPreferredSize(new Dimension(575, 330));
        refreshButton.setText("refresh");
        refreshButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                refreshButton_actionPerformed(e);
            }
        });
        inLabel.setText("perspective:");
        collapseButton.setText("collapse all");
        collapseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                collapseButton_actionPerformed(e);
            }
        });
        colOneButton.setText("<==");
        colOneButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                colOneButton_actionPerformed(e);
            }
        });
        expOneButton.setText("==>");
        expOneButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                expOneButton_actionPerformed(e);
            }
        });
        expandButton.setText("expand all");
        expandButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                expandButton_actionPerformed(e);
            }
        });
        this.setLayout(borderLayout1);
        jPanel2.setLayout(flowLayout2);
        jPanel1.setLayout(flowLayout1);
        refreshPerspectiveComboBox();
        //initialize tree
        lastSelectedNid = 0;
        int theRootNid = parent.parent.state1.getCOLAB_ROOT();
        rootRow = new TreeDataRow();
        perspectiveName = parent.parent.state1.getCurrentPerspectiveName();
        rootRow.setDescription(perspectiveName);
        rootRow.setNid(theRootNid);
        rootNode = new DefaultMutableTreeNode(rootRow);
        rootPath =  new TreePath(rootNode.getPath());
        treeModel = new DefaultTreeModel(rootNode);
        tree = new JTree(treeModel);
        tree.setEditable(false);
        tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        tree.setShowsRootHandles(true);
        treeScrollPane = new JScrollPane(tree);
        explodeButton.setText("explode subtree");
        explodeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                explodeButton_actionPerformed(e);
            }
        });
        perspectiveComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                perspectiveComboBox_actionPerformed(e);
            }
        });
        //Listen for when the selection changes.
        tree.addTreeSelectionListener(new TreeSelectionListener() {
            public void valueChanged(TreeSelectionEvent e) {
                try {
                    DefaultMutableTreeNode node = (DefaultMutableTreeNode) (e.getPath().getLastPathComponent());
                    TreeDataRow theRow = (TreeDataRow) node.getUserObject();

                    setLastSelectedNid(theRow.getNid());
                    parent.processTreeSelection(theRow);
                }
                catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
        //Listen for when mouse clicked or double-clicked in tree
        MouseListener ml = new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                int selRow = tree.getRowForLocation(e.getX(), e.getY());
                TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
                if (selRow != -1) {
                    if (e.getClickCount() == 1) {
                        mySingleClick(selRow, selPath);
                    }
                    else if(e.getClickCount() == 2) {
                        myDoubleClick(selRow, selPath);
                    }
                }
            }
        };
        comparisonButton.setText("comparison");
        comparisonButton.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            comparisonButton_actionPerformed(e);
          }
        });
        personalButton.setText("personal");
        personalButton.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            personalButton_actionPerformed(e);
          }
        });
        tree.addMouseListener(ml);
        negotiationButton.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            negotiationButton_actionPerformed(e);
          }
        });
        discussionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                discussionButton_actionPerformed(e);
            }
        });
        groupButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                groupButton_actionPerformed(e);
            }
        });
        negotiationButton.setMaximumSize(new Dimension(115, 27));
        negotiationButton.setMinimumSize(new Dimension(115, 27));
        negotiationButton.setPreferredSize(new Dimension(115, 27));
        negotiationButton.setText("negotiation");
        discussionButton.setText("discussion");
        discussionButton.setPreferredSize(new Dimension(115, 27));
        discussionButton.setMinimumSize(new Dimension(115, 27));
        discussionButton.setMaximumSize(new Dimension(115, 27));
        groupButton.setText("group");
        groupButton.setPreferredSize(new Dimension(95, 27));
        groupButton.setMinimumSize(new Dimension(95, 27));
        groupButton.setMaximumSize(new Dimension(95, 27));
        this.add(treeScrollPane, BorderLayout.CENTER);    //add tree
        this.add(jPanel1, BorderLayout.SOUTH);
        jPanel1.add(expandButton, null);
        jPanel1.add(expOneButton, null);
        jPanel1.add(explodeButton, null);
        jPanel1.add(colOneButton, null);
        jPanel1.add(collapseButton, null);
        this.add(jPanel2, BorderLayout.NORTH);
        jPanel2.add(groupButton, null);
        jPanel2.add(discussionButton, null);
        jPanel2.add(negotiationButton, null);
        jPanel2.add(personalButton, null);
        jPanel2.add(comparisonButton, null);
        jPanel2.add(inLabel, null);
        jPanel2.add(perspectiveComboBox, null);
        jPanel2.add(refreshButton, null);
    }

    /**
    Fill the JTree with a Vector of contents visible in the active perspective.
    Note that the TreeDataRows are filled in listMgr and currently contain the following:
         description contains nodes.name, the title or summary or name of the note
         perspectiveName contains the author's name, either original author or last editor
    */
    public void refreshTree() {
        try {
            tabbedPane.setHourglassCursor();         //signal user to wait during slow processing
            clear();
            int theRootNid = parent.getRootNid();    //defined in GulchPane, override in GulchDiscuss, etc.
// we should cache these lists in the client state and retrieve them when possible
//instead of going across the net and recomputing them
//especially when we have multiple windows with the same tree
//The disadvantage is we do not update contents this way
            theList = parent.getList();              //defined in GulchPane, override in GulchDiscuss, etc.
            perspectiveName = parent.getRootName();
            rootRow.setDescription(perspectiveName);
            rootRow.setNid(theRootNid);

            if (theList.size() > 0) {
                fillTree();                           //rootNode and theList are global variables
            }
            treeModel.reload();
            maxDepth = rootNode.getDepth() + 1;
            currentDepth = 1;
            scrollToNid(getLastSelectedNid());
            tabbedPane.setDefaultCursor();             //turn off hourglass cursor
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
    Fill the JTree from the Vector
    */
    public void fillTree() {
        TreeDataRow aRow;
        int myParent;
        DefaultMutableTreeNode parentNode;
        for (int i = 1; i < theList.size(); i++) {          //skip first element = COLAB_ROOT_CONTENT
            aRow = (TreeDataRow) theList.elementAt(i);
            myParent = aRow.getParentIndex();
            if (myParent < 0) {
                parentNode = rootNode;
            }
            else {
                TreeDataRow parentRow = (TreeDataRow) theList.elementAt(myParent);
                parentNode = parentRow.getNode();
            }
            //add newNode to tree at end of children of parentNode
            DefaultMutableTreeNode ptr = addObject(parentNode, true, aRow);
            aRow.setNode(ptr);                   //update tree pointer for aRow in theList
        }
    }

    /**
    Fill perspectiveComboBox with alpha list of perspectives
    */
    void refreshPerspectiveComboBox() {
        Vector items = parent.parent.state1.getListOfPerspectives();
        if (perspectiveComboBox.getItemCount()>0) {perspectiveComboBox.removeAllItems();}
        //add items and set Selected Item to current perspective
        int currentNid = parent.parent.getCurrentPerspective();
        //Vector currentVector = parent.parent.getDescription(currentNid);
        //String currentName = (String) currentVector.elementAt(1);
        String currentName = parent.parent.getCurrentPerspectiveName();
        for (int i = 0; i < items.size(); i++) {
            NodeDataRow row = (NodeDataRow) items.elementAt(i);
            perspectiveComboBox.addItem(row);
            if (row.getName().equalsIgnoreCase(currentName)) {
                perspectiveComboBox.setSelectedItem(row);
            }
        }
        start = true;
        return;
    }

    /**
    get the Nid of the perspective selected in the perspectiveComboBox
    */
    int getSelectedPerspectiveNid() {
        NodeDataRow row = (NodeDataRow) perspectiveComboBox.getSelectedItem();
        return row.getNid();
     }


    /**
    get the Name of the perspective selected in the perspectiveComboBox
    */
    String getSelectedPerspectiveName() {
        NodeDataRow row = (NodeDataRow) perspectiveComboBox.getSelectedItem();
        return row.getDescription();

     }

    /**
    return the DefaultMutableTreeNode that is currently selected, or null
    */
    public DefaultMutableTreeNode getSelectedNode() {
        DefaultMutableTreeNode node = null;
        if (tree.getSelectionCount() > 0) {
            TreePath currentSelection = tree.getSelectionPath();
            if (currentSelection != null) {
                node = (DefaultMutableTreeNode) (currentSelection.getLastPathComponent());
//System.out.println("found selected node");
            }
        }
        return node;
    }

    /**
    return the TreeDataRow that is currently selected, or null
    */
    public TreeDataRow getSelectedRow() {
        return (TreeDataRow) (getSelectedNode().getUserObject() );
    }

    /**
     *  return a vector of TreeDataRows which are open (visible) in the
     *  current tree structure
     *
     *  Method added by Witt Sparks 9/4/00 to support XML generation
     */
    public Vector getOpenRows() {
      TreePath path;
      DefaultMutableTreeNode node;
      Vector v = new Vector();
      // Traverse the JTree looking for open nodes
      int rowCount = tree.getRowCount();
      for (int i = 0; i < rowCount; i++) {
         path = tree.getPathForRow(i);
         node = (DefaultMutableTreeNode)path.getLastPathComponent();
         v.addElement(node.getUserObject());
      }

      return v;
    }

    /**
    refreshPerspective() -- called after a perspective button is pressed
    */
    void refreshPerspective(int newP, String newPName) {
//System.out.println("new perspective #" + newP + ": " + newPName);
        int oldP = parent.parent.getCurrentPerspective();
        if (oldP != newP) {parent.parent.interfaceMgr1.logChange(InterfaceMessageDef.LOG_CHANGE_PERSPECTIVE, oldP, oldP, newP); }
        //reset current perspective and refresh display
        parent.parent.setCurrentPerspective(newP);
        parent.parent.setCurrentPerspectiveName(newPName);
        if (start) {
            start = false;
            parent.refreshContent();
            start = true;
        }
        else {
            parent.refreshContent();
        }
    }

    /**
    process action in the comboBox
    */
    void perspectiveComboBox_actionPerformed(ActionEvent e) {
        try {
//System.out.println("perspectiveComboBox_actionPerformed called" );
            if (start) {                                //skip when called by system rather than user action
                int newP = getSelectedPerspectiveNid();
                if (newP != currentP) {
                    currentP = newP;
                    String pName = getSelectedPerspectiveName();
                    start = false;                      //do not call this recursively from refreshPerspective
                    refreshButton_actionPerformed(e);
                    start = true;
//System.out.println("perspectiveComboBox_actionPerformed executed: " + currentP );
                }
            }

        }
        catch (Exception ex) {
//System.out.println("old perspective: " + currentP);
            //ex.printStackTrace();
        }
    }

    /**
    process the refresh-in-perspective button.
    Save the selection in the perspectiveComboBox as the current perspective
    and then refresh the tree contents
    also refresh the other pane for change in perspective
    */
    void refreshButton_actionPerformed(ActionEvent e) {
        int newP = getSelectedPerspectiveNid();
        String newPName = getSelectedPerspectiveName();
        //change mode if selected group, personal or comparison
        if (newP == parent.parent.state1.getRootPerspectiveNid()) {
            parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_GROUP);
        }
        else {
            if (newP == parent.parent.state1.getHomePerspectiveNid()) {
                parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_PERSONAL);
            }
            else {
                if (newP == parent.parent.state1.getComparisonPerspectiveNid()) {
                    parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_COMPARISON);
                }
                else {
                    parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_OTHER);
                }
            }
        }
        refreshPerspective(newP, newPName);
    }

    /**
    process the group perspective button.
    */
    void groupButton_actionPerformed(ActionEvent e) {
        parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_GROUP);
        refreshPerspective(parent.parent.state1.getRootPerspectiveNid(), parent.parent.state1.getRootPerspectiveName());
    }

    /**
    process the discussion perspective button.
    */
    void discussionButton_actionPerformed(ActionEvent e) {
        parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_DISCUSSION);
        refreshPerspective(parent.parent.state1.getRootPerspectiveNid(), parent.parent.state1.getRootPerspectiveName());
    }

    /**
    process the negotiation perspective button -- this is now the "Group" button.
    */
    void negotiationButton_actionPerformed(ActionEvent e) {
        parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_NEGOTIATION);
        refreshPerspective(parent.parent.state1.getRootPerspectiveNid(), parent.parent.state1.getRootPerspectiveName());
    }

    /**
    process the personal perspective button.
    */
    void personalButton_actionPerformed(ActionEvent e) {
        parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_PERSONAL);
        int newP = parent.parent.getHomePerspective();
        String newPName = parent.parent.getHomePerspectiveName();
        //reset current perspective and refresh display
        refreshPerspective(newP, newPName);
    }

    /**
    process the comparison perspective button.
    */
    void comparisonButton_actionPerformed(ActionEvent e) {
        parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_COMPARISON);
        int newP = parent.parent.state1.getComparisonPerspectiveNid();
        String newPName = parent.parent.state1.getComparisonPerspectiveName();
        //reset current perspective and refresh display
        refreshPerspective(newP, newPName);
    }

    /**
    process the archive perspective button.
    */
    void archiveButton_actionPerformed(ActionEvent e) {
        parent.parent.state1.setCurrentDisplayMode(InterfaceMessageDef.GET_NODES_ARCHIVE);
        int newP = parent.parent.state1.getComparisonPerspectiveNid();
        String newPName = parent.parent.state1.getComparisonPerspectiveName();
        //reset current perspective and refresh display
        refreshPerspective(newP, newPName);
    }

    /**
    Collapse tree down to root
    */
    private void collapseTree() {
        int count = tree.getRowCount();
        for (int i = count - 1; i > -1; i--) {
            tree.collapseRow(i);
        }
    }

    /**
    Collapse tree down to root
    */
    private void collapseButton_actionPerformed(ActionEvent e) {
        currentDepth = 2;
        collapseTree();
        expandTree(rootNode, currentDepth);
        tree.scrollPathToVisible(rootPath);
    }

    /**
    Collapse tree one level
    */
    private void colOneButton_actionPerformed(ActionEvent e) {
        if (currentDepth > 1) {
            collapseTree();
            expandTree(rootNode, --currentDepth);
            tree.scrollPathToVisible(rootPath);
        }
    }

    /**
    Expand tree one level
    */
    private void expOneButton_actionPerformed(ActionEvent e) {
        if (currentDepth < maxDepth) {
            collapseTree();
            expandTree(rootNode, ++currentDepth);
            tree.scrollPathToVisible(rootPath);
        }
    }

    /**
    Explode tree below selected node
    */
    private void explodeButton_actionPerformed(ActionEvent e) {
        TreePath currentSelection = tree.getSelectionPath();
        if (currentSelection != null) {
            DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)(currentSelection.getLastPathComponent());
            expandTree(currentNode, maxDepth);
            tree.scrollPathToVisible(rootPath);
        }
    }


    /**
    Expand tree completely
    */
    private void expandButton_actionPerformed(ActionEvent e) {
        if (currentDepth < maxDepth) {
            currentDepth = maxDepth;
            expandTree(rootNode, maxDepth);
            tree.scrollPathToVisible(rootPath);
        }
    }

    /**
    recursive method to expand tree to a given level
    */
    private void expandTree(DefaultMutableTreeNode node, int level) {
        if (level < 2) {            //if only want 1 level, just make root node visible
            TreePath path = new TreePath(node.getPath());
            tree.scrollPathToVisible(path);
        }
        else {
            int count = node.getChildCount();
            if (count == 0) {        //this is a leaf node -- make it visible
                TreePath path = new TreePath(node.getPath());
                tree.scrollPathToVisible(path);
            }
            else {
                for (int i = 0; i < count; i++) {    //expand children of this node
                    DefaultMutableTreeNode childNode = (DefaultMutableTreeNode) node.getChildAt(i);
                    expandTree(childNode, level - 1);
                }
            }
        }
    }

    /**
    Remove all nodes except the root node.
    */
    public void clear() {
        rootNode.removeAllChildren();
        treeModel.reload();
    }

    /**
    Remove a node. Do not remove root node.
    */
    public void removeNode(DefaultMutableTreeNode currentNode) {
        MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
        if (parent != null) {
            treeModel.removeNodeFromParent(currentNode);
        }
    }

    /**
    Remove the currently selected node.
    */
    public void removeCurrentNode() {
        TreePath currentSelection = tree.getSelectionPath();
        if (currentSelection != null) {
            DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
                         (currentSelection.getLastPathComponent());
            MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
            if (parent != null) {
                treeModel.removeNodeFromParent(currentNode);
                return;
            }
        } 
        // Either there was no selection, or the root was selected.
        toolkit.beep();
    }

    /**
    Add child to the currently selected node.
    */
    public DefaultMutableTreeNode addObject(boolean atEnd, Object child) {
        DefaultMutableTreeNode parentNode = null;
        TreePath selectedPath = tree.getSelectionPath();
        if (selectedPath == null) {
            parentNode = rootNode;
        } else {
            parentNode = (DefaultMutableTreeNode) (selectedPath.getLastPathComponent());
        }
        return addObject(parentNode, atEnd, child);
    }

    public DefaultMutableTreeNode addObject(DefaultMutableTreeNode parent, boolean atEnd, Object child) {
        return addObject(parent, atEnd, child, false);
    }

    public DefaultMutableTreeNode addObject(DefaultMutableTreeNode parent, boolean atEnd, Object child, boolean shouldBeVisible) {
        DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(child);
        if (parent == null) {
            parent = rootNode;
        }
        if (atEnd) {
            treeModel.insertNodeInto(childNode, parent, parent.getChildCount());
        }
        else {
            treeModel.insertNodeInto(childNode, parent, 0);
        }
        // Make sure the user can see the lovely new node.
        if (shouldBeVisible) {
            tree.expandPath(new TreePath(parent.getPath()));
            tree.scrollPathToVisible(new TreePath(childNode.getPath()));
        }
        return childNode;
    }

    public void scrollToNid(int nid) {
        if (nid > 0) {
            DefaultMutableTreeNode currentNode = findInTree(rootNode, nid);
            if (currentNode != null) {
                DefaultMutableTreeNode parentNode = (DefaultMutableTreeNode) currentNode.getParent();
                if (parentNode != null) {
                    tree.expandPath(new TreePath(parentNode.getPath()));
                    tree.scrollPathToVisible(new TreePath(currentNode.getPath()));
                }
            }
        }
    }

    private DefaultMutableTreeNode findInTree(DefaultMutableTreeNode node, int nid) {
        TreeDataRow row = (TreeDataRow) node.getUserObject();
        if (nid == row.getNid()) {
            return node;
        }
        else {
            for (int i = 0; i < node.getChildCount(); i++) {    //expand children of this node
                DefaultMutableTreeNode childNode = (DefaultMutableTreeNode) node.getChildAt(i);
                DefaultMutableTreeNode foundNode = findInTree(childNode, nid);
                if (foundNode != null) {return foundNode; }
            }
        }
        return null;
    }

    /**
    process single mouse click in tree
    */
    public void mySingleClick(int selRow, TreePath selPath) {
//System.out.println("mySingleClick" );
    }

    /**
    process double mouse click in tree
    */
    public void myDoubleClick(int selRow, TreePath selPath) {
//System.out.println("myDoubleClick" );
    }

    public void setLastSelectedNid(int newLastSelectedNid) {
        if (delayLastSelectedNid) {delayLastSelectedNid = false; }   //if we want to delay change, just reset flag
        else {lastSelectedNid = newLastSelectedNid; }
    }

    public int getLastSelectedNid() {
        return lastSelectedNid;
    }

    //call setDelayLastSelectedNid() to  setLastSelectedNid() and delay the next call to it.
    //the next call me be an unwanted call from change of focus.
    public void setDelayLastSelectedNid(int newLastSelectedNid) {
        setLastSelectedNid(newLastSelectedNid);
        delayLastSelectedNid = true;
    }

}












