/**
*  Title:           InterfaceMessageDef
*  Version:         1.0
*  Copyright:       Copyright (c) 1999
*  Author:          Rogerio
*  Organization:    L3D
*  Description:     Defines messages used in the communication between client and server applications
*/

package pow2000;

public class InterfaceMessageDef {

   /**
    * definitions of databases and computer addresses
    */
    //spaces defined in spaces table initialized in ColabCreateDB.java:
    //  gulch        --  Logan School
    //  webguide1    --  CSCW Demo
    //  webguide2    --  Readings 99
    //  webguide3    --  WebGuide demo
    //  gulch_test1  --  discussion of WebGuide design
    //  gulch_test2  --  negotiation interface project for Tammy's UI course, Spring '00
    //  gulch_test3  --  Group Genius Guide
    //
    //  colab        --  central DB for Pow2000
    //  gerry        --  Gerry's journal
    //  research     --  Research 99 seminar discussion
    //  design       --  discussion of WebGuide design
    //  interface    --  negotiation interface project for Tammy's UI course, Spring '00
    //
   final static public String DBname = "design";
   final static public String DBcentralSpace = "colab";
   final static public String DBdefaultSpace = "design";
   final static public String DBdriver = "gwe.sql.gweMysqlDriver";
   final static public String computerDatabase = "webguide.cs.colorado.edu";
   final static public String DBurl = "jdbc:mysql://" + computerDatabase + ":3306/" + DBname;
   final static public String DBcentral = "jdbc:mysql://" + computerDatabase + ":3306/" + DBcentralSpace;
   final static public String DBusername = "webguide";
   final static public String DBpasswd = "webguide";
   final static public String DBport = "5553";
   final static public int DBportValue = 5553;

   final static public String computerServer = "localhost";
   //final static public String computerServer = "webguide.cs.colorado.edu";

   /**
    * messages determining operation
    */
   final static int GETSPACESLIST = 1;
   final static int VALIDATELOGIN = 2;
   final static int AUTOMATELOGIN = 3;
   final static int GETNODESFORDISPLAY = 4;
   final static int LOGCHANGE = 5;
   final static int SETNEWPASSWORD = 6;
   final static int GETSTATEMENT = 10;
   final static int GETDESCRIPTION = 11;
   final static int ADDITEM = 30;
   final static int MOVEITEM = 31;
   final static int COPYITEM = 32;
   final static int LINKITEM = 33;
   final static int ADDSTATEMENT = 41;
   final static int EDITSTATEMENT = 42;
   final static int DELETESTATEMENT = 43;
   final static int ADDDISCUSSION = 44;
   final static int CREATEPERSPECTIVE = 50;
   final static int EDITPERSPECTIVE = 51;
   final static int DELETEPERSPECTIVE = 52;
   final static int INHERITPERSPECTIVE = 53;
   final static int CREATECATEGORY = 60;
   final static int DELETECATEGORY = 61;
   final static int CREATEPERSON = 65;
   final static int DELETEPERSON = 66;
   final static int CREATEGROUP = 70;
   final static int DELETEGROUP = 71;
   final static int CREATEWEBSITE = 80;
   final static int DELETEWEBSITE = 81;
   final static int MULTINODEDISPLAY = 82;

   /**
   * modes for getNodes(p, nid, mode)
   */
   final static public int GET_NODES_GROUP = 1;          //no Discussion, Proposal, Decision, viewer's Private
   final static public int GET_NODES_DISCUSSION = 2;     //no Proposal, Decision, viewer's Private
   final static public int GET_NODES_NEGOTIATION = 3;    //viewer's Private
   final static public int GET_NODES_PERSONAL = 4;       //viewer's Discussions, Proposals, Decisions, Private
   final static public int GET_NODES_OTHER = 5;          //owner's Discussions, Proposals, Decisions, viewer's Private
   final static public int GET_NODES_COMPARISON = 6;     //viewer's Private
   final static public int GET_NODES_ARCHIVE = 7;        //viewer's Private, but include deleted notes

   /**
   * send status messages
   */
   //NORETURN signals not to wait for a return message
   final static int NORETURN = 98;

   /**
    * return status messages
    */
   final static int OBJECT_ADDED = 100;
   final static int PERSPECTIVE_ADDED = 101;
   final static int OBJECT_EDITED = 102;
   final static int OBJECT_DELETED = 103;
   final static int PERSPECTIVE_ACCESSED = 104;
   final static int USER_VALID = 105;
   final static int DB_UPDATED = 106;
   final static int OBJECT_SELECTED = 107;
   final static int PERSPECTIVE_DELETED = 108;

   /**
    * error messages
    */
   final static int USER_NOT_VALID = 201;
   final static int OPERATION_NOT_VALID = 202;
   final static int NO_PERMISSION = 203;
   final static int OBJECT_NOT_ADDED = 204;

   /**
    * type of object retrieved
    */
	final static int PERSP_ELEMENT = 301;
	final static int OBJECT_ELEMENT = 302;
	final static int USER_ELEMENT = 303;

	/**
	 * define object types
	 */
	final static int OBJ_URL = 401;
	final static int OBJ_ANNOTATION = 402;
	final static int OBJ_VIRTUALCOPY = 403;
	final static int OBJ_DISCUSSION = 404;

	/**
	 * control communications
	 */
	final static int END_CONNECTION = 501;
	final static int SHUT_DOWNSERVER = 502;

	/**
	 * log codes for InterfaceMgrServer
	 */
 	final static public int LOG_CHANGE_PERSPECTIVE = 1;   // set in GulchTreePane
	final static public int LOG_CHANGE_AUTHOR = 2;        //
	final static public int LOG_CHANGE_PASSWORD = 3;      // set in InterfaceMgrServer in setNewPassword
	final static public int LOG_ADD_DISCUSSION = 4;       // set in InterfaceMgrServer in addDiscussion
	final static public int LOG_ADD_NOTE = 5;             // set in InterfaceMgrServer in addStatement
	final static public int LOG_EDIT_NOTE = 6;            // set in InterfaceMgrServer in editStatement
	final static public int LOG_DELETE_NOTE = 7;          // set in InterfaceMgrServer in deleteStatement
	final static public int LOG_MOVE_NOTE = 8;            // set in InterfaceMgrServer in moveItem
	final static public int LOG_COPY_NOTE = 9;            // set in InterfaceMgrServer in copyStatement
	final static public int LOG_LINK_NOTE = 10;           // set in InterfaceMgrServer in linkItem
	final static public int LOG_SEND_EMAIL = 11;          //
	final static public int LOG_READ_NOTE = 12;           // set in GulchDiscuss
	final static public int LOG_CHANGE_DB = 13;           // set in GulchLoginpane and InterfaceMgrServer in checkDB
	final static public int LOG_READ_MANUAL = 14;         // set in GulchWelcomePane
	final static public int LOG_MULTINODEDISPLAY = 15;    // set in
	final static public int LOG_TEST = 16;                // use for testing

}

