//Title:      InterfaceNetServer Net Connection
//Version:
//Copyright:  Copyright (c) 1998
//Author:     R.
//Company:    L3D
//Description: Server Side
package pow2000;

import java.net.*;
import java.io.*;
import java.lang.*;

  /**
  * The NetServer establishes a socket connection with the client application
  * It creates a listener, which receives all client's requestion for opperation.
  * Doing so, it creates the msgManager thread.
  * This thread is created by the server whenever it receives a request from the client
  *
  * It creates a new instance of PerspectiveMechanism for dealing with the Operation
  * msgManager deals with the Operaction
  * getResult gets the new values in DataSerialized Class
  * returns then to the client the result of the operation and dies...
  */

public class InterfaceNetServer {
  private Server serverSocket;
  private InterfaceMessageDef msgDef = new InterfaceMessageDef();

  /**
  * Constructor
  * Assign the db class to a local and private variable
  * Create the connection to a specific port
  */
  public InterfaceNetServer(int port) {
      try {
          serverSocket = new Server(port);
          serverSocket.serveRequests();
      } catch (Exception e) {
          System.out.println(e.getMessage());
          e.printStackTrace();
      }
  }

  public final class Server {
    private ServerSocket servsock;
    private boolean runserver;

    public Server(int port) throws Exception  {
        servsock = new ServerSocket(port);
        runserver = true;
    }

    private void stopServer()  {
        runserver = false;
    }

    public void serveRequests() throws IOException  {
        Socket sock;
        Thread thr;

        while(runserver) {
            sock = servsock.accept();
            thr = new Thread(new msgManager(sock, this), "threadSocket");
            thr.start();
//System.out.println("Creating a new thread from socket connection");
        }
        servsock.close();
    }
  }

  public class msgManager extends Thread {
       Socket sock;
       Server serverAdd;
       private InterfaceMgrServer interfaceMgr = new InterfaceMgrServer();

       public msgManager (Socket sck, Server server) {
           this.sock = sck;
           this.serverAdd = server;
       }

       public void run () {
           char ch;
           ObjectInputStream inMsg;
           ObjectOutputStream outMsg;
           Object intermediaryObj;
           boolean end = false;
           InterfaceDataSerialized msg;
           try {
               do {
                   // get InputStream from the Sock and deserialize it into the DataSerialized Class (msg)
                   inMsg =  new ObjectInputStream (sock.getInputStream());
                   msg = new InterfaceDataSerialized();
                   intermediaryObj = inMsg.readObject();
                   msg = (InterfaceDataSerialized) intermediaryObj;
                   //System.out.println("Oops, I got a message:"+msg.getCommand());
                   if (msg.getCommand() != msgDef.END_CONNECTION && msg.getCommand() != msgDef.SHUT_DOWNSERVER) {
                        // creates PesrpectiveMechanism for dealing with the Operation
                        // msgManager deals with the Operaction
                        // getResult gets the new values in DataSerialized Class
                        interfaceMgr.setMessage(msg);
                        interfaceMgr.msgManager();
                        msg = interfaceMgr.getResult();

  	    		        // Serialize the DataSerialized Class and Send it back to the Client
                        if (msg.getStatus() != InterfaceMessageDef.NORETURN) {
                            outMsg = new ObjectOutputStream(sock.getOutputStream());
                            outMsg.writeObject(msg);
                            outMsg.flush();
//System.out.println("returning:" + msg.getCommand());
                        }
                   } // if
                   else {
                        end = true;
                   }
                   // free memory
                   msg = null;
                   inMsg = null;
                   outMsg = null;
               }
               while (end == false);
               if (msg.getCommand() == msgDef.SHUT_DOWNSERVER)
                   this.serverAdd.stopServer();
               System.out.println("Socket Process Killed.");
               // free memory
               intermediaryObj = null;
               interfaceMgr = null;
           }
           catch (Exception e) {
               System.out.println(e.getMessage());
               e.printStackTrace();
           }
       } // run
  } // msgManager

}
