/**
*  Title:           LinkOrderedSet for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     comparator on lid for OrderedSet of LinkDataRows
*/

package pow2000;

import com.objectspace.jgl.OrderedSet;
import com.objectspace.jgl.BinaryPredicate;
import com.objectspace.jgl.OrderedSetIterator;

public class LinkOrderedSet extends OrderedSet {

    public LinkOrderedSet() {
        super();
    }

    public LinkOrderedSet(BinaryPredicate bp, boolean allowDuplicates) {
        super(bp, allowDuplicates);
    }

    /**
    find(lid) returns the LinkDataRow from the links table with the given lid.
    Search for lowerBound in the OrderedSet is guaranteed to be O(log N) using red & black trees.
    */
    public LinkDataRow find(int theLid) {
        LinkDataRow targetRow = new LinkDataRow();
        targetRow.setLid(theLid);
        OrderedSetIterator i = lowerBound(targetRow);
        if (i.atEnd()) {
            return new LinkDataRow();
        }
        else {
            return (LinkDataRow) i.get();
        }
    }

}

