/**
*  Title:           LinkSeqPredicate for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     comparator on sequence for OrderedSet of LinkDataRows
*/

package pow2000;

import com.objectspace.jgl.BinaryPredicate;

public class LinkSeqPredicate implements BinaryPredicate {

    public LinkSeqPredicate() {
    }

    /**
    execute() returns true if the fist Object is less than the second Object
    both Objects are LinkDataRows
    */
    public boolean execute(Object first, Object second) {
        LinkDataRow firstRow = (LinkDataRow) first;
        LinkDataRow secondRow = (LinkDataRow) second;
        int firstSeq = firstRow.getSequence();
        int secondSeq = secondRow.getSequence();
        if (firstSeq <= secondSeq) return true;
        else return false;
    }

}

