/**
*  Title:           NodeAlphaPredicate for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     comparator on Name for OrderedSet of NodeDataRows
*/

package pow2000;

import com.objectspace.jgl.BinaryPredicate;

public class NodeAlphaPredicate implements BinaryPredicate {

    public NodeAlphaPredicate() {
    }

    /**
    execute() returns true if the fist Object is less than the second Object
    Both Objects are nodeDataRows
    */
    public boolean execute(Object first, Object second) {
        NodeDataRow firstRow = (NodeDataRow) first;
        NodeDataRow secondRow = (NodeDataRow) second;
        String firstName = firstRow.getName().toLowerCase();
        String secondName = secondRow.getName().toLowerCase();
        if (firstName.compareTo(secondName) < 0) return true;
        else return false;
    }

}

