/**
*  Title:           NodeNidPredicate for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     comparator on sequence for OrderedSet of NodeDataRows
*/

package pow2000;

import com.objectspace.jgl.BinaryPredicate;

public class NodeNidPredicate implements BinaryPredicate {

    public NodeNidPredicate() {
    }

    /**
    execute() returns true if the fist Object is less than the second Object
    Both Objects are nodeDataRows
    */
    public boolean execute(Object first, Object second) {
        NodeDataRow firstRow = (NodeDataRow) first;
        NodeDataRow secondRow = (NodeDataRow) second;
        int firstNid = firstRow.getNid();
        int secondNid = secondRow.getNid();
        if (firstNid <= secondNid) return true;
        else return false;
    }

}

