/**
*  Title:           NodeOrderedSet for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     comparator on nid for OrderedSet of NodeDataRows
*/

package pow2000;

import com.objectspace.jgl.OrderedSet;
import com.objectspace.jgl.BinaryPredicate;
import com.objectspace.jgl.OrderedSetIterator;

public class NodeOrderedSet extends OrderedSet {

    public NodeOrderedSet() {
        super();
    }

    public NodeOrderedSet(BinaryPredicate bp, boolean allowDuplicates) {
        super(bp, allowDuplicates);
    }

    /**
    find(Nid) returns the NodeDataRow from the nodes table with the given Nid, or a new NodeDataRow with nid = 0.
    Search for lowerBound in the OrderedSet is guaranteed to be O(log N) using red & black trees.
    */
    public NodeDataRow find(int theNid) {
        NodeDataRow targetRow = new NodeDataRow();
        targetRow.setNid(theNid);
        OrderedSetIterator i = lowerBound(targetRow);
        if (i.atEnd()) {
            return new NodeDataRow();
        }
        else {
            return (NodeDataRow) i.get();
        }
    }

}

