/**
*  Title:           ParentSeqRow for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     ParentSeqRow contains two ints
*
*              Structure of a row of data from the ParentSeqRow:
*                1. int parent
*                2. int sequence
*/

package pow2000;

public class ParentSeqRow implements Cloneable{
    private int parent = 0;
    private int sequence = 0;

    public ParentSeqRow() {
            jbInit();
    }

    public ParentSeqRow(int aParent, int aSequence) {
        parent = aParent;
        sequence = aSequence;
        jbInit();
    }

    public synchronized Object clone() {
        ParentSeqRow theClone = new ParentSeqRow(parent, sequence);
        return theClone;
    }

    private void jbInit() {
    }

    public String toString() {
        String theString = "Parent: " + parent;
        return theString;
}

    public String asString() {
        String theString = "ParentSeqRow";
        theString += ": Parent= " + parent;
        theString += "; Sequence= " + sequence;
        return theString;
    }

    public void setParent(int newParent) {
        parent = newParent;
    }

    public int getParent() {
        return parent;
    }

    public void setSequence(int newSequence) {
        sequence = newSequence;
    }

    public int getSequence() {
        return sequence;
    }

}

