/**
*  Title:           PositionOrderedSet for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     comparator on nid for OrderedSet of PositionDataRows
*/

package pow2000;

import com.objectspace.jgl.OrderedSet;
import com.objectspace.jgl.BinaryPredicate;
import com.objectspace.jgl.OrderedSetIterator;

public class PositionOrderedSet extends OrderedSet {

    public PositionOrderedSet() {
        super();
    }

    public PositionOrderedSet(BinaryPredicate bp, boolean allowDuplicates) {
        super(bp, allowDuplicates);
    }

    /**
    find(Nid) returns the NodeDataRow from the nodes table with the given Nid, or a new NodeDataRow with nid = 0.
    Search for lowerBound in the OrderedSet is guaranteed to be O(log N) using red & black trees.
    */
    public PositionDataRow find(int theNid) {
        PositionDataRow targetRow = new PositionDataRow();
        targetRow.setNid(theNid);
        OrderedSetIterator i = lowerBound(targetRow);
        if (i.atEnd()) {
            return new PositionDataRow();
        }
        else {
            return (PositionDataRow) i.get();
        }
    }

}

