/**
*  Title:           TreeSeqPredicate for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     comparator for OrderedSet of nodeDataRows
*/

package pow2000;

import com.objectspace.jgl.BinaryPredicate;

public class TreeSeqPredicate implements BinaryPredicate {

    public TreeSeqPredicate() {
    }

    /**
    execute() returns true if the first Object is less than the second Object.
    Both Objects are TreeDataRows
    */
    public boolean execute(Object first, Object second) {
        TreeDataRow firstRow = (TreeDataRow) first;
        TreeDataRow secondRow = (TreeDataRow) second;
        int firstSeq = firstRow.getSequence();
        int secondSeq = secondRow.getSequence();
        if (firstSeq <= secondSeq) return true;
        else return false;
    }

}

