/**
*  Title:           VisibleDataRow for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     VisibleDataRow defines a class of DataRows with content from the visible() method in ListMgr.
*
*              Structure of a row of VisibleDataRow:
*                1. int perspective
*                2. OrderedSet of Integers
*/

package pow2000;

import java.util.*;
import com.objectspace.jgl.OrderedSet;

public class VisibleDataRow implements Cloneable{
    private int thePerspective = 0;                         //the perspective for Vector
    private OrderedSet theOrderedSet = new OrderedSet();    //the OrderedSet for this perspective

    public VisibleDataRow() {
            jbInit();
    }

    public VisibleDataRow(int aPerspective, OrderedSet anOrderedSet) {
        setPerspective(aPerspective);
        setOrderedSet(anOrderedSet);
        jbInit();
    }

    public synchronized Object clone() {
        VisibleDataRow theClone = new VisibleDataRow(thePerspective, theOrderedSet);
        return theClone;
    }

    private void jbInit() {
    }

    public String toString() {
        return "" + thePerspective;
    }

    public String asString() {
        String theString = "VisibleDataRow";
        theString += "; Persp= " + thePerspective;
        theString += "; OrderedSet size= " + theOrderedSet.size();
        return theString;
    }

    public void setPerspective(int newPerspective) {
        thePerspective = newPerspective;
    }

    public int getPerspective() {
        return thePerspective;
    }

    public void setOrderedSet(OrderedSet newOrderedSet) {
        theOrderedSet = newOrderedSet;
    }

    public OrderedSet getOrderedSet() {
        return theOrderedSet;
    }

}

