/**
*  Title:           VisibleOrderedSet for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     comparator on lid for OrderedSet of LinkDataRows
*/

package pow2000;

import java.util.*;
import com.objectspace.jgl.OrderedSet;
import com.objectspace.jgl.OrderedSetIterator;

public class VisibleOrderedSet extends OrderedSet {

    public VisibleOrderedSet() {
        super();
    }

    public VisibleOrderedSet(VisiblePerspectivePredicate vp, boolean allowDuplicates) {
        super(vp, allowDuplicates);
    }

    /**
    find(p) returns the Vector from the visibleFound Vector with the given p as its perspective.
    Search for lowerBound in the OrderedSet is guaranteed to be O(log N) using red & black trees.
    */
    public VisibleDataRow find(int p) {
        VisibleDataRow target = new VisibleDataRow(p, new OrderedSet());
        OrderedSetIterator i = lowerBound(target);
        if (i.atEnd()) {
            return new VisibleDataRow(0, new OrderedSet());  //signal no stored Vector found with 0 as its first element
        }
        else {
            return (VisibleDataRow) i.get();;     //return the stored VisibleDataRow
        }
    }

}

