/**
*  Title:           VisiblePerspectivePredicate for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 1998
*  Author:          Gerry Stahl
*  Organization:    L3D
*  Description:     comparator on sequence for VisibleOrderedSet of VisibleDataRows
*/

package pow2000;

import com.objectspace.jgl.BinaryPredicate;

public class VisiblePerspectivePredicate implements BinaryPredicate {

    public VisiblePerspectivePredicate() {
    }

    /**
    execute() returns true if the fist VisibleDataRow is less than the second VisibleDataRow
    Both VisibleDataRow contain an int perspective and a Vector hierarchy
    */
    public boolean execute(Object first,  Object second) {
        VisibleDataRow firstVisibleDataRow = (VisibleDataRow) first;
        VisibleDataRow secondVisibleDataRow = (VisibleDataRow) second;
        if (firstVisibleDataRow.getPerspective() <= secondVisibleDataRow.getPerspective()) return true;
        else return false;
    }

}

