/**
*  Title:           Dataset for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 2000
*  Author:          Gerry Stahl & Aaron Martin
*  Organization:    L3D
*  Description:     Class for XML DTD
*/

package xml2000;

//import Note;
//import Link;
import java.util.*;
import java.io.BufferedWriter;
import java.io.IOException;

public class Dataset {
    public static int totalNotes = 0;
    String xml_version = "1.0";
    String system = "";
    String creator = "";
    String created = "";
    ArrayList description = new ArrayList();
    ArrayList comment = new ArrayList();
    static ArrayList notes = new ArrayList();
    static ArrayList linked = new ArrayList();
    static ArrayList links = new ArrayList();

    public void setXMLVersion(String version) {
      this.xml_version = version;
    }

    public void setSystem(String s) {
      this.system = s;
    }

    public void setCreator(String s) {
      this.creator = s;
    }

    public void setCreated(String s) {
      this.created = s;
    }

    public void setDescription(String s) {
      this.addDescription(s);
    }

    public void addDescription(String s) {
      this.description.add(s);
    }

    public void setCommnet(String s) {
      this.addComment(s);
    }

    public void addComment(String s) {
      this.comment.add(s);
    }

    public void setNote(Note n) {
      this.addNote(n);
    }

    public void addNote(Note n) {
      notes.add(n);
    }

    public static void addLink(Link link) {
      //Note parent;
      //Note child;
      //parent = findNote(link.getFromHref());
      //child = findNote(link.getToHref());
      //parent.addChildNote(child);
      links.add(link);
      Integer[] temp = new Integer[] { new Integer(link.getToHref())}; //aaraylist doesn't like
      List li = java.util.Arrays.asList(temp);            //ints
      linked.addAll(li);
    }


    public static void addLink(int to, int from) {
       Note parent;
       Note child;
       parent = findNote(to);
       child = findNote(from);
       parent.addChildNote(child);
       //Link link = new Link(from, to);
       //links.add(link);
       //Integer[] temp = new Integer[] { new Integer(from)}; //aaraylist doesn't like
       //List li = java.util.Arrays.asList(temp);            //ints
       //linked.addAll(li);
    }

    static Note findNote(int id) {
      for(int i=0; i < notes.size(); i++) {
        Note temp;
        temp = (Note) notes.get(i);
        if(temp.noteID == id)
          return temp;
      }
      Note bad = new Note(-1);
      //display error break...
      return bad;
    }

    void removeNote(int id) {
      for(int i=0; i < notes.size(); i++) {
        Note temp;
        temp = (Note) notes.get(i);
        if(temp.noteID == id)
          notes.remove(i);
         // return 1;
      }
      //return 0; //this might be a good place for exception handleing
    }

    public void generateRXML(int depth, StringBuffer buf) {
      Note temp;
      //StringBuffer buf = new StringBuffer();
      for (int i=0; i <linked.size(); i++) {
        Integer temp1 = (Integer) linked.get(i);
        removeNote(temp1.intValue());
      }
      generateDTD("r");
       buf.append("<DATASET ");
      buf.append("XML_VERSION = \"");
      buf.append((String) this.xml_version);
      buf.append("\" SYSTEM = \"");
      buf.append((String) this.system);
      buf.append("\" CREATE_DATE = \"");
      buf.append((String) this.created);
      buf.append("\" CREATOR = \"");
      buf.append((String) this.creator);
      //buf.append("\">\n");
      //need to add attributes
      //pull the description and comment into another metdod
      //for(int i=0; i < description.size(); i++) {
      buf.append(" DESCRIPTION = \"");
      String bob = (String) description.get(0);
      buf.append(bob);
      //  buf.append("</description>\n");
      //}
      //for(int i=0; i < comment.size(); i++) {
      buf.append(" COMMENT = \"");
      String bob1 = (String) comment.get(0);
      buf.append(bob1);
      buf.append(">\n");
      for(int i=0; i < notes.size(); i++) {
        temp = (Note) notes.get(i);
        temp.generateRXML(depth+3, buf);
      }
      buf.append("</DATASET>\n");
    }

    public void generateNRXML(int depth, StringBuffer buf) {
      Note temp;
      Link templink;
      //StringBuffer buf = new StringBuffer();
      for (int i=0; i <linked.size(); i++){
        Integer temp1 = (Integer) linked.get(i);
        removeNote(temp1.intValue());
      }
      generateDTD("nr");
      buf.append("<DATASET ");
      buf.append("XML_VERSION = \"");
      buf.append((String) this.xml_version);
      buf.append("\" SYSTEM = \"");
      buf.append((String) this.system);
      buf.append("\" CREATE_DATE = \"");
      buf.append((String) this.created);
      buf.append("\" CREATOR = \"");
      buf.append((String) this.creator);
      //buf.append("\">\n");
      //need to add attributes
      //pull the description and comment into another metdod
      //for(int i=0; i < description.size(); i++) {
      buf.append(" DESCRIPTION = \"");
      String bob = (String) description.get(0);
      buf.append(bob);
      //  buf.append("</description>\n");
      //}
      //for(int i=0; i < comment.size(); i++) {
      buf.append(" COMMENT = \"");
      String bob1 = (String) comment.get(0);
      buf.append(bob1);
      buf.append(">\n");
      //}
      for(int i=0; i < notes.size(); i++) {
        temp = (Note) notes.get(i);
        temp.generateNRXML(depth+3, buf);
      }
      for(int i=0; i< links.size(); i++) {
        templink = (Link) links.get(i);
        templink.generateXML(depth+3, buf);
      }
      buf.append("</DATASET>\n");


    }

    void generateDTD(String type) {
      //impliment me!!!
    }

}

