/**
*  Title:           Link for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 2000
*  Author:          Gerry Stahl & Aaron Martin
*  Organization:    L3D
*  Description:     Class for XML DTD
*/

package xml2000;

import java.util.*;
//import Dataset;

public class Link extends Dataset {

  String xmllinkAttr = "";
  String inline = "";
  String role = "";
  String title = "";
  String show = "";
  String actuate = "";
  String behavior = "";
  String content_role = "";
  String content_title = "";
  int lid = 0;
  String type = "";
  String perspective = "";
  int tHref, fHref;
  String tRole="", fRole = "";
  String txml_link, fxml_link = "";
  String author="", seq="", created="";
  ArrayList existingLIDs = new ArrayList();

  static int links = 0;

  Link () {
    links++;
    this.lid = links;
  }

  Link(int to, int from) {
    links++;
    this.lid = links;
    this.tHref = to;
    this.fHref = from;
  }

  public void setLinkID(int ID) {
 //   changeExisting(ID);  if lids are unique then everything must have a lid
    this.lid = ID;
  }

  public int getToHref() {
    return this.tHref;
  }

  public int getFromHref() {
    return this.fHref;
  }

  public void setFlocator(int from) {
    this.fHref = from;
  }

  public void setTlocator(int to) {
    this.tHref = to;
  }

  public void setxmllinkAttr(String value) {
    this.xmllinkAttr = value;
  }

  public void setInline(String value) {
    this.inline = value;
  }

  public void setLinkRole(String value) {
    this.role = value;
  }

  public void setFlocatorRole(String value) {
    this.fRole = value;
  }

  public void setTlocatorRole(String value) {
    this.tRole = value;
  }

  public void setTitle(String value) {
    this.title = value;
  }

  public void setShow(String value) {
    this.show = title;
  }

  public void setActuate(String value) {
    this.actuate = value;
  }

  public void setBehavior(String value) {
    this.behavior = value;
  }

  public void setContent_Role(String value) {
    this.content_role = value;
  }

  public void setContent_Title(String value) {
    this.content_title = value;
  }

  public void setType(String value) {
    this.type = value;
  }

  public void setPerspective(String value) {
    this.type = value;
  }

  public void setTlocatorXML_Link(String value) {
    this.txml_link = value;
  }

  public void setFlocatorXML_Link(String value) {
    this.fxml_link = value;
  }

  public void setSeq(String value) {
    this.seq = value;
  }

  public void setAuthor(String value) {
    this.author = value;
  }

  public void setCreated(String value) {
    this.created = value;
  }

  String setDepth(int depth) {
    String temp = "";
    for (int i = 0; i < depth; i++)
      temp = temp + " ";
    return temp;
  }
  public void generateXML(int depth, StringBuffer buf) {
    buf.append(setDepth(depth) + "<LINK XML:LINK = \"" + xmllinkAttr +
      "\" inline = \"" + inline + "\" role = \"" + role + "\" title = \"" + title +
      "\" show = \"" + show + "\" actuate = \"" + actuate + "\" behavior = \"" + behavior +
      "\" content-role = \"" + content_role + "\" content-title = \"" + content_title +
      "\" lid = \"" + lid + "\" type = \"" + type + "\" perspective = \"" + perspective +
      "\" seq = \"" + seq + "\" author = \"" + author + "\" created = \"" + created + "\">\n");
    buf.append(setDepth(depth) + "  <flocator XML:LINK = \"" + fxml_link +
      "\" href = \"" + fHref + "\" role = \"" + fRole + "\">\n");
    buf.append(setDepth(depth) + "  <tlocator XML:LINK = \"" + txml_link +
      "\" href = \"" + tHref + "\" role = \"" + tRole + "\">\n");
    buf.append(setDepth(depth) + "</LINK>\n");
  }

}