/**
*  Title:           Note for COLAB
*  Version:         1.0
*  Copyright:       Copyright (c) 2000
*  Author:          Gerry Stahl & Aaron Martin
*  Organization:    L3D
*  Description:     Class for XML DTD
*/

package xml2000;

import java.util.*;
//import author;

public class Note {
  static int total_notes;

  public int noteID;
  int parentID;
  ArrayList childIDs = new ArrayList();
  ArrayList childNotes = new ArrayList();
  String title="";
  String content="";
  String link_type = "";
  String sequence="";
  String kind="";
  String created="";
  ArrayList additional = new ArrayList();
  ArrayList Author = new ArrayList();

  static int newNoteID() {
    total_notes++;
    return total_notes;
  }

  public Note() {
    this(newNoteID());
  }

  public Note(int id) {
    this.noteID = id;
  }

  public int getID() {
    return this.noteID;
  }

  public void generateLink(int from, int to) {
     this.parentID = from;
     Link link = new Link(to, from);
     Dataset.addLink(link);
     Integer[] temp = new Integer[] { new Integer(to)}; //aaraylist doesn't like
     List li = java.util.Arrays.asList(temp);            //ints
     childIDs.addAll(li);
  }

  public void addChildNote(Note child) {
    this.childNotes.add(child);
    this.generateLink(this.noteID, child.getID());
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public void setContent(String content) {
    this.content = content;
  }

  public void setAdditional(String additionalText) {
    this.addAdditional(additionalText);
  }

  public void addAdditional(String additionalText) {
    this.additional.add(additionalText);
  }

  public void setAuthor(String authorName) {
    this.addAuthor(authorName);
  }

  public void addAuthor(String authorName) {
    author temp = new author(authorName);
    Author.add(temp);
  }

  public void addAuthor(author currentAuthor) {
    Author.add(currentAuthor);
  }

  public void setEmail(String authorName, String email) {
    this.addEmail(authorName, email);
  }

  public void addEmail(String authorName, String email) {
    for(int i=0; i < Author.size(); i++) {
      author temp = (author) Author.get(i);
      if(temp.name == authorName)
        temp.addEmail(email);
    }
  }

  public void setAddress(String authorName, String address) {
    this.addAddress(authorName, address);
  }

  public void setlink_type(String s) {
    this.link_type = s;
  }

  public void setSequence(String s) {
    this.sequence = s;
  }

  public void setNote_kind(String s) {
    this.kind = s;
  }

  public void setCreated(String s) {
    this.created = s;
  }

  public void addAddress(String authorName, String address) {
    for(int i=0; i < Author.size(); i++) {
      author temp = (author) Author.get(i);
      if(temp.name == authorName)
        temp.addAddress(address);
    }
  }

  public void generateRXML(int depth, StringBuffer buf) {
    buf.append(setDepth(depth) + "<NOTE LINK_KIND=\"" + this.link_type + "\"\n" +
                        " SEQUENCE=\"" + this.sequence + "\"\n" +
                        " NOTE_KIND=\"" + this.kind + "\"\n" +
                        " CREATE_DATE=\"" + this.created + "\"\n" +
                        " TITLE=\"" + this.title + "\"\n"
                        );
    //for(int i=0;i<this.Author.size(); i++) {
      author temp = (author) this.Author.get(0);
      temp.generateXML(depth+3, buf);
    //}
    buf.append(setDepth(depth) + ">\n");
    buf.append(setDepth(depth) + "   <FIELD>" + this.content + "</FIELD>\n");
    for(int i=0; i<this.childNotes.size(); i++) {
      Note temp1 = (Note) this.childNotes.get(i);
      temp1.generateRXML(depth+8, buf);
    }
    //for(int i=0; i<this.additional.size(); i++)
    //  buf.append(setDepth(depth) + "   <additional>" + this.additional.get(i) + "</additional>\n");
    buf.append(setDepth(depth) + "</NOTE>\n");
  }

  static String setDepth(int depth) {
    String temp = "";
    for (int i = 0; i < depth; i++)
      temp = temp + " ";
    return temp;
  }

  public void generateNRXML(int depth, StringBuffer buf) {
     buf.append(setDepth(depth) + "<NOTE LINK_KIND=\"" + this.link_type + "\"\n" +
                        " SEQUENCE=\"" + this.sequence + "\"\n" +
                        " NOTE_KIND=\"" + this.kind + "\"\n" +
                        " CREATE_DATE=\"" + this.created + "\"\n" +
                        " TITLE=\"" + this.title + "\"\n"
                        );
    //for(int i=0;i<this.Author.size(); i++) {
      author temp = (author) this.Author.get(0);
      temp.generateXML(depth+3, buf);
    //}
    buf.append(setDepth(depth) + ">\n");
    buf.append(setDepth(depth) + "   <FIELD>" + this.content + "</FIELD>\n");
    for(int i=0; i<this.childNotes.size(); i++) {
      Note temp1 = (Note) this.childNotes.get(i);
      temp1.generateNRXML(depth, buf);
    }
  }

}


